function monoedgeDisplayShortcode() {
    var ruid = document.getElementById( 'js_monoedge_location_uuid' ).value;
    jQuery( '.monoedge-ordering-location' ).attr( 'data-location', ruid );
    jQuery( '.monoedge-reservations-location' ).attr( 'data-location', ruid );
    document.getElementById( 'js_monoedge_mor_ordering' ).value = monoedge_createShortcode( 'ordering', ruid );
    document.getElementById( 'js_monoedge_mor_reservations' ).value = monoedge_createShortcode( 'reservations', ruid );
    document.getElementById( 'js_monoedge_mor_full_menu' ).value = monoedge_createShortcode( 'full-menu', ruid );
    document.getElementById( 'js_monoedge_mor_opening_hours' ).value = monoedge_createShortcode( 'opening-hours', ruid );
    document.getElementById( 'js_monoedge_mor_promotions' ).value = monoedge_createShortcode( 'promotions', ruid );
    ajax_update_default_location( ruid );
}

function monoedgeAccountIdToUrl() {
    var el = jQuery( '#js_monoedge_mor_acid' ).find( 'option:selected' ),
        acid = el.val(),
        setup = jQuery( '#monoedge-acid-setup' ),
        menu = jQuery( '#monoedge-acid-menu' ),
        setup_href = setup.attr( 'href' ),
        menu_href = menu.attr( 'href' );
    if( el.length <= 0 ) {
        el = jQuery( '#js_monoedge_mor_acid' );
        acid = el.val();
    }
    if( setup_href !== undefined ) {
        if( setup_href.indexOf( '&acid' ) >= 0 || menu_href.indexOf( '&acid' ) >= 0 ) {
            setup_href = setup_href.substr( 0, setup_href.indexOf( '&acid' ) );
            menu_href = menu_href.substr( 0, menu_href.indexOf( '&acid' ) );
        }
        setup.attr( 'href', setup_href + '&acid=' + acid );
        menu.attr( 'href', menu_href + '&acid=' + acid );
        ajax_update_default_location( el.attr( 'data-uid' ) );
    }
}

function ajax_update_default_location( location ) {
    var data = {
        action: 'monoedge_set_default_location',
        location: location,
        ajax_nonce: monoedge_ajax_url.ajax_nonce
    };
    jQuery.ajax( {
        url: window.ajaxurl,
        type: "POST",
        data: data,
        dataType: "json",
        success: function ( data ) {
        },
        error: function ( xhr, status, error ) {
            console.log( 'Status[' + status + '] Error[' + error + ']' );
        }
    } );
}
// Refreshes the following shortcodes: menu and opening hours
function monoedgeRefreshShortcode( element ) {
    var ruid = document.getElementById( 'js_monoedge_location_uuid' ).value;
    //window.location.href = jQuery(element).data('page') + '&refresh_menu=' + ruid;

    // Fix for alert appearing everytime you customize a button.
    // If the page is changed the alert doesn't appear anymore.
    // Delete the refresh_menu parameter from the URL.
    let form = jQuery( '<form action="' + jQuery( element ).data( 'page' ) + '" method="post">' +
        '<input type="text" name="' + jQuery( element ).data( 'name' ) + '" value="' + ruid + '" />' +
        '</form>' );
    jQuery( 'body' ).append( form );
    form.submit();
}
