var MONOEDGE = MONOEDGE || {};
( function ( $ ) {
    "use strict";
    MONOEDGE.core = {
        _doc: '',
        _body: '',
        ajaxRequest: '',
        activeScreen: 'screen_sign_up',
        consentInstance: '',
        consent: false,

        domLoaded: function () {
            console.log( 'domLoaded' );
            MONOEDGE.core.init();
        },
        init: function () {
            this.consentInstance = $('#monoedge-consent');
            this.consent = this.consentInstance.attr('data-consent') === 'yes';
            MONOEDGE.core.monoedge_buttons()
            MONOEDGE.core.forms();
            MONOEDGE.core.settings_tabs();
            let redirect = $('.monoedge-wrapper');
            if( redirect.length > 0 && redirect.attr('data-redirect') === 'monoedge_load_screen' ){
                $('[data-action="monoedge_load_screen"]').trigger('click');
            }
        },
        settings_tabs: function(){
            $('.settings-tab').off('click').on('click', function(e){
                let _this = $(this);
                if(!_this.hasClass('active') ){

                    _this.parent().find( '.active' ).removeClass( 'active' );
                    _this.addClass( 'active' );
                    $( '.monoedge-settings-content.active' ).removeClass( 'active' );
                    $( '.' + _this.attr( 'data-id' ) ).addClass( 'active' );
                }
            });
        },
        dropdown_change: function(){
            var location_uuid = $( '#js_monoedge_location_uuid' ).val(),
                data = { location_uuid: location_uuid },
                anim_btn = $( '.monoedge-white-box.publish label' ),
                list = $('.monoedge-list.flx-col');
            MONOEDGE.core.monoedge_circular_animation( 'on', anim_btn );
            MONOEDGE.core.monoedge_circular_animation( 'on', list );
            MONOEDGE.core.ajaxCall( 'monoedge_get_updated_urls', data, 'on_dropdown_overview_AjaxComplete', [ anim_btn, list ] );
        },
        on_dropdown_overview_AjaxComplete: function( args, response ){
            let data = response.data;
            if( data.todo !== undefined ){
                $('.monoedge-list').empty().append( data.todo );
            }
            if( data.admin_url !== undefined ){
                $('.monoedge-section-header .monoedge-button').attr( 'data-flow_url', data.admin_url );
            }

            MONOEDGE.core.monoedge_circular_animation( 'off', args[0] );
            MONOEDGE.core.monoedge_circular_animation( 'off', args[1] );
            MONOEDGE.core.update();

        },
        monoedge_circular_instance: '',
        monoedge_circular_animation: function ( state, _btn ) {
            _btn = (_btn === undefined ) ? $('.screen-active') : _btn;
            if( _btn === undefined || _btn.length <= 0  ){
                return false;
            }
            if( state === 'on' ) {
                let btn_animation = $( '#monoedge_circular_animation > div' ).clone();
                _btn.append( btn_animation );
                _btn.addClass( 'disabled' );
            } else if( state === 'off' ) {
                _btn.find( '> .monoedge-loader-animation' ).remove();
                _btn.removeClass( 'disabled' );
            }
        },
        forms: function(){
            //jQuery(this).serialize()
            $('form.monoedge-form').off('submit').on('submit', function(e){
                e.preventDefault();
                let _this = $( this ),
                    submit = $( 'input[type="submit"]', _this ),
                    action = submit.attr( 'data-action' ),
                    checkbox = _this.find( 'input[type="checkbox"]' );
                if( checkbox.length > 0 ){
                    _this.find('#partner_program').val( checkbox.is(':checked') );
                }
                MONOEDGE.core.notificationsFormsHide();
                MONOEDGE.core.monoedge_circular_animation( 'on', undefined );
                MONOEDGE.core.ajaxCall( action, _this.serialize(), 'onFormAjaxComplete', submit  )
            });
        },
        onFormAjaxComplete: function(args, response){
            let data = response.data;
            if( data.errors !== undefined ){
                MONOEDGE.core.monoedge_circular_animation( 'off', undefined );
                MONOEDGE.core.onFormErrors( data.errors );
                return false;
            }

            if( data.action === 'disconnect' ){
                window.open( args.attr( 'data-id' ), '_parent' );
                return false;
            }
            if( data.action === 'redirect' ){
                window.open( data.screen_url, '_parent' );
                return false;
            }

            if(data.status === 'success' ){
                MONOEDGE.core.monoedge_circular_animation( 'off', undefined );
                if( data.empty === 'true' ){
                    $( '.screen-active' ).removeClass( 'screen-active' );
                }
                $( '.monoedge-wrapper' ).append( data.screen );
                MONOEDGE.core.update();
            }else{
                MONOEDGE.core.monoedge_circular_animation( 'off', undefined );
            }
            MONOEDGE.core.steps_overview_update();

        },
        onFormErrors: function ( errors ){
            let notif_wrap = $( '.monoedge-notifications' );
            if( notif_wrap.length > 0 ){
                notif_wrap.removeClass('disabled');
                let error_html = '';
                $.each( errors, function(key, val){
                    error_html += '<span>' + val + '</span>';
                } );
                notif_wrap.find( '.monoedge-form-notification' ).empty().append( error_html );
            }
        },
        notificationsFormsHide: function(){
            let notif_wrap = $( '.monoedge-notifications' );
            if( notif_wrap.length > 0 ) {
                notif_wrap.removeClass( 'disabled' ).addClass( 'disabled' );
            }
        },
        monoedge_buttons:function(){
            $( '.monoedge-button-action-demo-page' ).off('click').on('click', function(e){
                console.log("clicked monoedge-button-action-demo-page")
                e.stopImmediatePropagation();
                e.stopPropagation();
                e.preventDefault();
                let _this = $( this );
                if( !_this.hasClass('ajax-active') && !_this.hasClass('state-disabled') ){
                    _this.removeClass( 'ajax-active' ).addClass('ajax-active');
                    MONOEDGE.core.monoedge_create_demo_page( _this );
                }
            } );
            $( '.monoedge-button-action-redirect' ).off('click').on('click', function(e){
                console.log("clicked monoedge-button-action-redirect")
                let _this = $( this );
                setTimeout( function () {
                    window.open( _this.attr( 'data-overview' ), '_parent' );
                }, 200 );
            } );
            $( '.monoedge-button-action' ).off('click').on('click', function(e){
                console.log("clicked monoedge-button-action")
                e.stopImmediatePropagation();
                e.stopPropagation();
                e.preventDefault();
                let _this = $( this ),
                    _type = _this.attr( 'data-action' ),
                    _id = _this.attr('id'),
                    _title = _this.attr( 'data-title' );

                if( ( _this.attr( 'data-completed' ) === 'true' || _this.hasClass( 'state-disabled' ) )){
                    if( ( _id !== 'setup_menu' && _id !== 'enroll_partner_program' ) || ( _id === 'setup_menu' && _this.prev().attr( 'data-completed' ) === 'false') ){
                        return true;
                    }
                }

                //EVENT TRACKING
                if( _title !== undefined ){
                    let  selected_location_uuid = '';
                    if( $('#js_monoedge_location_uuid').length > 0 ){
                        selected_location_uuid = $( '#js_monoedge_location_uuid' ).val();
                    }
                    MONOEDGE.core.monoedge_send_tracking( { type: 'todo', id: _id, todo: _title, location_uuid: selected_location_uuid } );
                }

                // Delay the click event in order to have time to run the ajax call
                // for the event tracking
                if( _type === undefined && _this.attr('href') !== '#' ){
                    // location.reload()
                    setTimeout( function () {
                        window.open( _this.attr( 'href' ), '_parent' );
                    }, 200 );
                    return true;
                }
                try {
                    MONOEDGE.core[_type]( _this );
                } catch ( error ) {
                    console.log( 'Error calling method[' + _type + '] - error message:', error.message.replace( '_type', '"' + _type + '"' ) );
                }
            });
        },

        monoedge_create_demo_page: function ( btn ) {
            MONOEDGE.core.monoedge_circular_animation( 'on', btn );
            MONOEDGE.core.ajaxCall( 'monoedge_create_demo_page', {}, 'monoedge_create_demo_page_ajaxComplete', btn );
        },

        monoedge_create_demo_page_ajaxComplete: function ( args, response ) {
            args.removeClass('ajax-active');
            $('.monoedge-button-action-demo-page').each(function(){
                $(this).attr('href', response.data.url);
            });
            MONOEDGE.core.monoedge_circular_animation( 'off', args );
            window.open( response.data.url, '_parent' );
        },

        monoedge_send_tracking:function( data ){
            if( MONOEDGE.core.consentInstance.length <= 0 ){
                console.clear();
                console.info('We are outside the MonoEdge Panel. Let the back-end decide!');
            }else if( !MONOEDGE.core.consent ){
                console.clear();
                console.warn('Consent not given!');
            }
            MONOEDGE.core.ajaxCall( 'monoedge_tracking', data, 'monoedge_tracking_ajaxComplete', '' );
        },

        monoedge_tracking_ajaxComplete:function( args, response ){
        },

        monoedge_load_screen: function( _btn ){
            let data = {
                screen: _btn.attr( 'data-screen' )
            };
            MONOEDGE.core.monoedge_circular_animation( 'on', undefined );
            MONOEDGE.core.ajaxCall( _btn.attr('data-action'), data, 'on_load_screen_ajaxComplete', _btn );
        },
        on_load_screen_ajaxComplete: function ( args, response ) {

            if( response.data.empty === 'true' ) {
                $( '.screen-active' ).removeClass( 'screen-active' );
            }
            $( '.monoedge-wrapper' ).empty().append( response.data.screen );
            MONOEDGE.core.update();
        },

        monoedge_switch_set: function( _btn ){
            let checkbox = _btn.find('input'),
                data = {
                option_name: _btn.attr( 'data-option' ),
                option_value: checkbox.is(':checked') ? 'no' : 'yes'
            };

            checkbox.prop('checked', !checkbox.is( ':checked' ) );
            MONOEDGE.core.ajaxCall( 'monoedge_set_option', data, 'onSwitchComplete', '' );
            MONOEDGE.core.monoedge_set_consent( data.option_value );
            if( data.option_value === 'yes' ){
                MONOEDGE.core.monoedge_send_tracking( { type: 'consent', consent: 'true', source: 'settings' } );
            }
        },
        onSwitchComplete: function( args, repsonse ){
        },
        monoedge_set_consent: function( val ){
            $('#monoedge-consent').attr('data-consent', val );
            MONOEDGE.core.consent = val === 'yes';
        },
        monoedge_set_option: function( _btn ){
            let data = {
                option_name: _btn.attr('data-option'),
                option_value: _btn.attr('data-value')
            };
            if( _btn.attr('data-screen') !== undefined ){
                data['screen'] = _btn.attr('data-screen');
            }

            MONOEDGE.core.monoedge_circular_animation( 'on', undefined );
            MONOEDGE.core.ajaxCall( 'monoedge_set_option', data, 'onSetOptionAjaxComplete', _btn )

            if( data.option_name === 'share_usage_data'  ) {
                MONOEDGE.core.monoedge_set_consent( data.option_value );
                if( data.option_value === 'yes' ){
                    MONOEDGE.core.monoedge_send_tracking( { type: 'consent', consent: 'true', source: 'wizard' } );
                }
            }
        },
        onSetOptionAjaxComplete: function( args, response ){
            let data = response.data;
            if( data.status === 'success' ) {
                if( data.action === 'redirect' ) {
                    if( args.attr('data-id') === 'new_tab_link' ){
                        window.open( args.attr( 'data-flow-url' ), args.attr( 'data-target' ) );
                    }
                    window.open( data.screen_url, '_parent' );
                    return false;
                }
                if( data.action === 'remove-overlay' ){
                    $('.screen-active').removeClass('screen-active');
                    return false;
                }

                if( data.screen !== undefined ){
                    $( '.monoedge-wrapper' ).empty().append( data.screen );
                }
                else{
                    MONOEDGE.core.screen_change( args );
                }
            } else {
                console.log( 'onSetOptionAjaxComplete Error', data );
            }
        },
        monoedge_chosen_options: function( _btn ){
            let data = {},
                selected = [];
            _btn.closest('.monoedge-form-field').find('> .monoedge-filed-checkbox input').each( function( id, el){
                el = $(el);
                data[ el.attr( 'id' ) ] = el.is( ":checked" );
                if( el.is( ":checked" ) ){
                    selected.push( el.attr('data-tracking') );
                }
            } );
            MONOEDGE.core.monoedge_circular_animation( 'on', undefined );
            MONOEDGE.core.ajaxCall( 'monoedge_chosen_options', data, 'onChosenOptionsAjaxComplete', _btn )
            // if( selected.length > 0 ){
            //     MONOEDGE.core.monoedge_send_tracking( { type: 'options', options: selected } );
            // }

        },
        onChosenOptionsAjaxComplete: function( args, response ){
            let data = response.data;
            if( data.status === 'success' ) {
                MONOEDGE.core.screen_change( args );
            } else {
                MONOEDGE.core.monoedge_circular_animation( 'off', undefined );
                console.log( 'onChosenOptionsAjaxComplete Error', data );
            }
        },
        option_dismiss: function( _btn ){
            let data = { option: _btn.attr('data-id') };
            MONOEDGE.core.ajaxCall( 'monoedge_setup_options_remove', data, 'onOptionsDismissAjaxComplete', _btn )
        },
        onOptionsDismissAjaxComplete: function( args, response ){
            let data = response.data;
            if( data.status === 'success' ) {
                args.closest( '.monoedge-list-item' ).remove();
            } else {
                console.log( 'onChosenOptionsAjaxComplete Error', data );
            }
        },
        screen_change: function(_btn){
            let new_screen = _btn.attr( 'data-id' ),
                screen = $( '#' + new_screen );
            MONOEDGE.core.notificationsFormsHide();
            if( new_screen === 'new_tab_link' ){

                setTimeout( function () {
                    location.reload();
                }, 2000 );                
                setTimeout( function () {
                    window.open( _btn.attr( 'data-flow-url' ), '_blank' );
                }, 200 );

                return false;
            }
            if( new_screen === 'redirect' ){
                window.open( _btn.attr( 'data-id_url' ), '_parent' );
                return false;
            }
            if( screen.length > 0 ){
                MONOEDGE.core.monoedge_circular_animation( 'off', undefined );
                var new_screenInst = $( '#' + new_screen );
                $( '.screen-active' ).removeClass( 'screen-active' );
                new_screenInst.addClass('screen-active');
            }
            else if( $('.monoedge-wrapper.overview').length > 0 ){
                $( '.screen-active' ).removeClass( 'screen-active' );
            }
            MONOEDGE.core.steps_overview_update();
        },
        steps_overview_update: function (){
            let overviewSteps = $('.monoedge-steps-overview'),
                activeScreen = $('.screen-active').attr('id'),
                step = 1,
                id = 0;
            if( activeScreen === 'screen_login' || activeScreen === 'screen_sign_up' || activeScreen === 'screen_forgot_password' ){
                id = 1;
            }
            else if( activeScreen === 'screen_options' ){
                id = 2;
            }
            else if( activeScreen === 'screen_data_usage' || activeScreen === 'screen_partner_program' || activeScreen === 'screen_alternative_flow' ){
                id = 3;
            }
            overviewSteps.find( '> .current' ).removeClass( 'current' );
            overviewSteps.find( '> .active' ).removeClass( 'active' );

            for( step = 1; step <= id; step++ ){
                if( step < id ){
                    overviewSteps.find( '> div:nth-of-type(' + step + ')' ).addClass( 'active' );
                } else if( step === id ){
                    overviewSteps.find( '> div:nth-of-type(' + step + ')' ).addClass( 'current' );
                }
            }

        },
        choose_options: function(_btn){
            MONOEDGE.core.overlay_show(_btn);
        },
        open_new_tab: function(_btn){
            window.open( _btn.attr('data-id'), '_blank' );
        },
        run_screen: function(_btn){
            MONOEDGE.core.overlay_close(_btn);
            MONOEDGE.core.show_iframe( _btn.attr('href') );

        },
        show_iframe: function( url ){
            let over_iframe = $( '.monoedge-section-iframe' );
            $('.monoedge-step.current').addClass('active');
            over_iframe.css('display', 'flex');
            over_iframe.find('iframe').attr('src', url);
        },
        overlay_close: function(_btn){
            let overlay = _btn.closest( '.monoedge-section-overlay' );
            if( overlay.length > 0){
                _btn.closest( '.monoedge-section-overlay' ).css( 'display', 'none' );
            }
        },
        overlay_show: function( _btn ){
            let overlay = _btn.closest( '.monoedge-section-overlay' );
            if( overlay.length > 0 ) {
                _btn.closest( '.monoedge-section-overlay' ).css( 'display', 'flex' );
            }
        },
        update: function(){
            MONOEDGE.core.monoedge_buttons();
            MONOEDGE.core.forms();
        },
        ajaxCall: function ( action, data, onCompleteMethod = '', onCompleteArgs = '' ) {
            MONOEDGE.core.ajaxRequest = $.ajax( {
                    url: monoedge_ajax_url.ajax_url + ( window.location.search.indexOf( 'debug=true' ) > 0 ? '?debug=true' : '' ),
                    type: "POST",
                    data: {
                        action: action,
                        data: data,
                        ajax_nonce: monoedge_ajax_url.ajax_nonce
                    },
                    dataType: "html",
                    onCompleteMethod: onCompleteMethod,
                    dataFilter: function ( data, dataType ) {
                        return data = {
                            data: $.parseJSON( data ),
                            onCompleteMethod: onCompleteMethod,
                            onCompleteArgs: onCompleteArgs,
                            dataType: 'json'
                        };
                    }
                }
            );
            MONOEDGE.core.ajaxRequestFail( MONOEDGE.core.ajaxRequest );
            MONOEDGE.core.ajaxRequest.done( function ( response ) {
                if( response.onCompleteMethod !== '' ) {
                    MONOEDGE.core[response.onCompleteMethod]( response.onCompleteArgs, response );
                }
                else{
                    console.log( 'ajaxCall DONE -> RESPONSE', response );
                }

            } );
        },
        ajaxRequestFail: function ( request, parent, instance, args ) {
            request.fail( function ( jqXHR, exception ) {
                var messag = "";
                if( jqXHR.status === 0 ) {
                    messag = "Internet not working! Verify network connection!";
                } else if( jqXHR.status == 404 ) {
                    messag = "[404] - Requested page not found. Check that files are on the server!";
                } else if( jqXHR.status == 500 ) {
                    messag = "[500] - Internal Server Error!";
                } else if( exception === 'parsererror' ) {
                    messag = "Requested JSON parse failed!";
                } else if( exception === 'timeout' ) {
                    messag = "Time out error!";
                } else if( exception === 'abort' ) {
                    messag = "Ajax request aborted!";
                } else {
                    messag = "Uncaught Error: " + jqXHR.responseText;
                }
                console.log( 'request.fail', messag );
            } );
        },
    };
    document.addEventListener( "DOMContentLoaded", function ( event ) {
        if( document.readyState === 'interactive' ) {
            MONOEDGE.core.domLoaded();
            window.dispatchEvent( new Event( 'resize' ) );
        }
    } );
}( jQuery ) );