var MONOEDGE = MONOEDGE || {};
( function ( $ ) {
    "use strict";
    MONOEDGE.core = {
        _doc: '',
        _body: '',
        ajaxRequest: '',

        domLoaded: function () {
            console.log( 'backend widgets domLoaded' );
            MONOEDGE.core.init();
        },
        init: function () {
            MONOEDGE.core.monoedge_elementor_editor_events();
        },
        ajaxCall: function ( action, data, onCompleteMethod = '', onCompleteArgs = '' ) {
            MONOEDGE.core.ajaxRequest = $.ajax( {
                    url: monoedge_ajax_url.ajax_url + ( window.location.search.indexOf( 'debug=true' ) > 0 ? '?debug=true' : '' ),
                    type: "POST",
                    data: {
                        action: action,
                        data: data,
                    },
                    dataType: "html",
                    onCompleteMethod: onCompleteMethod,
                    dataFilter: function ( data, dataType ) {
                        return data = {
                            data: $.parseJSON( data ),
                            onCompleteMethod: onCompleteMethod,
                            onCompleteArgs: onCompleteArgs,
                            dataType: 'json'
                        };
                    }
                }
            );
            MONOEDGE.core.ajaxRequestFail( MONOEDGE.core.ajaxRequest );
            MONOEDGE.core.ajaxRequest.done( function ( response ) {
                if( response.onCompleteMethod !== '' ) {
                    MONOEDGE.core[response.onCompleteMethod]( response.onCompleteArgs, response );
                } else {
                    console.log( 'ajaxCall DONE -> RESPONSE', response );
                }

            } );
        },
        ajaxRequestFail: function ( request, parent, instance, args ) {
            request.fail( function ( jqXHR, exception ) {
                var messag = "";
                if( jqXHR.status === 0 ) {
                    messag = "Internet not working! Verify network connection!";
                } else if( jqXHR.status == 404 ) {
                    messag = "[404] - Requested page not found. Check that files are on the server!";
                } else if( jqXHR.status == 500 ) {
                    messag = "[500] - Internal Server Error!";
                } else if( exception === 'parsererror' ) {
                    messag = "Requested JSON parse failed!";
                } else if( exception === 'timeout' ) {
                    messag = "Time out error!";
                } else if( exception === 'abort' ) {
                    messag = "Ajax request aborted!";
                } else {
                    messag = "Uncaught Error: " + jqXHR.responseText;
                }
                console.log( 'request.fail', messag );
            } );
        },
    };
    document.addEventListener( "DOMContentLoaded", function ( event ) {
        if( document.readyState === 'interactive' ) {
            MONOEDGE.core.domLoaded();
            window.dispatchEvent( new Event( 'resize' ) );
        }
    } );
}( jQuery ) );
