<?php
if ( !defined( 'ABSPATH' ) ) {
    exit;
} // Exit if accessed directly

/**
 * This class contains utilities helpers for screenns, options and settings
 *
 * @since 1.0.0
 */
if ( !class_exists( 'Monoedge_Helper_Screens' ) ) {

    class Monoedge_Helper_Screens {

        const RESTAURANT_TOTAL_CLIENTS = 500;

        public static $_MONOEDGE = null;
        public static $_token = null;
        public static $_language = null;

        //_e( 'Connect to MonoEdge Account', 'monoedge-restaurant-system' )
        public static $_default_options = array(
            'title' => 'Default Options',
            'todo' => array(
                'connect_account' => array(
                    'title' => 'Connect to MonoEdge Account',
                    'subtitle' => '1 min',
                    'description' => '',
                    'tracking_title' => 'Connect to MonoEdge Account',
                    'url' => '',
                    'done' => 'false',
                    'dismissable' => false,
                    'state' => 'state-disabled'
                ),
                // 'test_redirect' => array(
                //     'title' => 'Test Redirect',
                //     'subtitle' => '5 sec',
                //     'tracking_title' => 'Test Redirect',
                //     'url' => '',
                //     'done' => 'false',
                //     'dismissable' => false,
                //     'state' => 'state-disabled',
                //     'alternative_url' => '{{token}}/home/setup/step1'
                // ),
                'select_server' => array(
                    'title' => 'Select a Server',
                    'subtitle' => '1 min',
                    'description' => '',
                    'tracking_title' => 'Select a Server',
                    'url' => '',
                    'done' => 'false',
                    'dismissable' => false,
                    'state' => 'state-disabled',
                    'required' => array(
                        'connect_account' => array(
                            'key' => 'done',
                            'compare' => 'equal',
                            'value' => 'true'
                        )
                    ),
                    'alternative_url' => '{{token}}/home/setup/step1'
                ),
                'setup_brand_location' => array(
                    'title' => 'Setup Brand/Store Profile',
                    'subtitle' => '5 min',
                    'description' => '',
                    'tracking_title' => 'Setup Brand/Store Profile',
                    'url' => '',
                    'done' => 'false',
                    'dismissable' => false,
                    'state' => 'state-disabled',
                    'required' => array(
                        'select_server' => array(
                            'key' => 'done',
                            'compare' => 'equal',
                            'value' => 'true'
                        )
                    ),
                    'alternative_url' => '{{token}}/home/setup/step2'
                ),
                'setup_shopappuser' => array(
                    'title' => 'Shop Application User Creation',
                    'subtitle' => '1 min',
                    'description' => '',
                    'tracking_title' => 'Shop Application User Creation',
                    'url' => '',
                    'done' => 'false',
                    'dismissable' => false,
                    'state' => 'state-disabled',
                    'required' => array(
                        'setup_brand_location' => array(
                            'key' => 'done',
                            'compare' => 'equal',
                            'value' => 'true'
                        )
                    ),
                    'alternative_url' => '{{token}}/home/setup/step3'
                ),
                'setup_branduser' => array(
                    'title' => 'Back Office Application User Creation',
                    'subtitle' => '1 min',
                    'description' => '',
                    'tracking_title' => 'Back Office Application User Creation',
                    'url' => '',
                    'done' => 'false',
                    'dismissable' => false,
                    'state' => 'state-disabled',
                    'required' => array(
                        'setup_brand_location' => array(
                            'key' => 'done',
                            'compare' => 'equal',
                            'value' => 'true'
                        )
                    ),
                    'alternative_url' => '{{token}}/home/setup/step3'
                ),
                // 'setup_menu' => array(
                //     'title' => 'Setup Menu',
                //     'subtitle' => '2 min per menu item',
                //     'tracking_title' => 'Setup Menu',
                //     'url' => '',
                //     'done' => 'false',
                //     'dismissable' => false,
                //     'state' => 'state-disabled',
                //     'required' => array(
                //         'setup_brand_location' => array(
                //             'key' => 'done',
                //             'compare' => 'equal',
                //             'value' => 'true'
                //         )
                //     ),
                //     'alternative_url' => '{{token}}&parent_window=wordpress&r=app.admin.setup.menu_app.menu_editor&hide_top_menu=true&hide_left_menu=true&hide_left_navigation=true&acid={{acc_id}}'
                // )
            )
        );

        public static $_extra_options = array(
            'general_setting' => array(
                'title' => 'General settings',
                'preselected' => 'true',
                'todo' => array(
                    'general_setting' => array(
                        'title' => 'General settings',
                        'subtitle' => '1 min',
                        'description' => 'Set up general settings for your store. Change the settings to suit your store, including tax rates, rounding of payments, eat-in/take-out, special taxes, and receipt formatting adn so on.',
                        'tracking_title' => 'General settings',
                        'url' => '',
                        'done' => 'false',
                        'dismissable' => false,
                        'state' => 'state-disabled',
                        'required' => array(
                            'setup_shopappuser' => array(
                                'key' => 'done',
                                'compare' => 'equal',
                                'value' => 'true'
                            ),
                            'setup_branduser' => array(
                                'key' => 'done',
                                'compare' => 'equal',
                                'value' => 'true'
                            )
                        ),
                        'alternative_url' => '{{token_brand}}/dashboard/location/{{location_uuid}}/shop/{{register_shop_uuid}}/setting/',
                    )
                )
            ),
            'reservation_setting' => array(
                'title' => 'Reservation settings',
                'preselected' => 'true',
                'todo' => array(
                    'reservation_setting' => array(
                        'title' => 'Reservation settings',
                        'subtitle' => '1 min',
                        'description' => 'Configure reservation settings. Change reservation tag color schemes, create custom tags, set rules for accepting reservations, create courses, set display settings in the store app, and other settings appropriate for your store.',
                        'tracking_title' => 'Reservation settings',
                        'url' => '',
                        'done' => 'false',
                        'dismissable' => false,
                        'state' => 'state-disabled',
                        'required' => array(
                            'setup_shopappuser' => array(
                                'key' => 'done',
                                'compare' => 'equal',
                                'value' => 'true'
                            ),
                            'setup_branduser' => array(
                                'key' => 'done',
                                'compare' => 'equal',
                                'value' => 'true'
                            )
                        ),
                        'alternative_url' => '{{token_brand}}/dashboard/location/{{location_uuid}}/shop/{{register_shop_uuid}}/setting/',
                    )
                )
            ),
            'reservation_businesshours' => array(
                'title' => 'Reservation business hours',
                'preselected' => 'true',
                'todo' => array(
                    'reservation_businesshours' => array(
                        'title' => 'Reservation business hours',
                        'subtitle' => '2 min',
                        'description' => 'Set hours of operation, lunch seating hours, dinner seating hours, holidays, etc.',
                        'tracking_title' => 'Reservation business hours',
                        'url' => '',
                        'done' => 'false',
                        'dismissable' => false,
                        'state' => 'state-disabled',
                        'required' => array(
                            'reservation_setting' => array(
                                'key' => 'done',
                                'compare' => 'equal',
                                'value' => 'true'
                            ),
                        ),
                        'alternative_url' => '{{token_shopapp}}/location/{{location_name}}/setting/reservation/businesshour',
                    )
                )
            ),
            'reservation_table' => array(
                'title' => 'Reservation table setting',
                'preselected' => 'true',
                'todo' => array(
                    'reservation_table' => array(
                        'title' => 'Reservation table setting',
                        'subtitle' => '3 min',
                        'description' => 'Set up all tables in the store. Set up the smallest unit, since they can be linked together.',
                        'tracking_title' => 'Reservation table setting',
                        'url' => '',
                        'done' => 'false',
                        'dismissable' => false,
                        'state' => 'state-disabled',
                        'required' => array(
                            'reservation_businesshours' => array(
                                'key' => 'done',
                                'compare' => 'equal',
                                'value' => 'true'
                            ),
                        ),
                        'alternative_url' => '{{token_shopapp}}/location/{{location_name}}/setting/reservation/table',
                    )
                )
            ),
            'reservation_layout' => array(
                'title' => 'Reservation table layout',
                'preselected' => 'true',
                'todo' => array(
                    'reservation_layout' => array(
                        'title' => 'Reservation table layout',
                        'subtitle' => '3 min',
                        'description' => 'Create table layouts. It also joins tables that can be joined together to create a multi-table. Multi-tables are used to accept group reservations.',
                        'tracking_title' => 'Reservation table layout',
                        'url' => '',
                        'done' => 'false',
                        'dismissable' => false,
                        'state' => 'state-disabled',
                        'required' => array(
                            'reservation_table' => array(
                                'key' => 'done',
                                'compare' => 'equal',
                                'value' => 'true'
                            ),
                        ),
                        'alternative_url' => '{{token_shopapp}}/location/{{location_name}}/setting/reservation/layout',
                    )
                )
            ),
            'reservation_businessdays' => array(
                'title' => 'Reservation business days',
                'preselected' => 'true',
                'todo' => array(
                    'reservation_businessdays' => array(
                        'title' => 'Reservation business days',
                        'subtitle' => '2 min',
                        'description' => 'Turn ON the business day on which you wish to accept reservations. This is turned on manually to ensure that the business day is correct.',
                        'tracking_title' => 'Reservation business days',
                        'url' => '',
                        'done' => 'false',
                        'dismissable' => false,
                        'state' => 'state-disabled',
                        'required' => array(
                            'reservation_table' => array(
                                'key' => 'done',
                                'compare' => 'equal',
                                'value' => 'true'
                            ),
                        ),
                        'alternative_url' => '{{token_shopapp}}/location/{{location_name}}/setting/reservation/businessday',
                    )
                )
            ),
            'reservation_createbutton' => array(
                'title' => 'Create reservation button codes',
                'preselected' => 'true',
                'todo' => array(
                    'reservation_createbutton' => array(
                        'title' => 'Create reservation button codes',
                        'subtitle' => '1 min',
                        'description' => 'Create the reservation button code in the style of your choice. Once created, copy the embed button code to your homepage and the URL to your SNS link or Google Business.',
                        'tracking_title' => 'Create reservation button codes',
                        'url' => '',
                        'done' => 'false',
                        'dismissable' => false,
                        'state' => 'state-disabled',
                        'required' => array(
                            'reservation_table' => array(
                                'key' => 'done',
                                'compare' => 'equal',
                                'value' => 'true'
                            ),
                        ),
                        'alternative_url' => '{{token}}/home/setup/linkrsvn',
                    )
                )
            ),
            'reservation_button' => array(
                'title' => 'Add a reservations button on your page',
                'preselected' => 'true',
                'todo' => array(
                    'reservation_button' => array(
                        'title' => 'Add a reservations button on your page',
                        'subtitle' => '1 min',
                        'description' => 'Add a reservations button on your page',
                        'tracking_title' => 'Add a reservations button on your page',
                        'url' => '',
                        'done' => 'false',
                        'dismissable' => false,
                        'state' => 'state-disabled',
                        'required' => array(
                            'reservation_createbutton' => array(
                                'key' => 'done',
                                'compare' => 'equal',
                                'value' => 'true'
                            ),
                        ),
                    )
                )
            ),
            'mobileorder_setting' => array(
                'title' => 'Mobile order settings',
                'preselected' => 'true',
                'todo' => array(
                    'mobileorder_setting' => array(
                        'title' => 'Mobile order settings',
                        'subtitle' => '1 min',
                        'description' => 'Configure the settings for mobile ordering. Set up the settlement method, mobile ordering application appearance, fonts, images, order rules, cancellation rules, sales limits, inventory, etc. as appropriate for your store.',
                        'tracking_title' => 'Mobile order settings',
                        'url' => '',
                        'done' => 'false',
                        'dismissable' => false,
                        'state' => 'state-disabled',
                        'required' => array(
                            'setup_shopappuser' => array(
                                'key' => 'done',
                                'compare' => 'equal',
                                'value' => 'true'
                            ),
                            'setup_branduser' => array(
                                'key' => 'done',
                                'compare' => 'equal',
                                'value' => 'true'
                            )
                        ),
                        'alternative_url' => '{{token_brand}}/dashboard/location/{{location_uuid}}/shop/{{online_shop_uuid}}/setting/',
                    )
                )
            ),
            'mobileorder_menu' => array(
                'title' => 'Mobile order menu',
                'preselected' => 'true',
                'todo' => array(
                    'mobileorder_menu' => array(
                        'title' => 'Mobile order menu',
                        'subtitle' => '1 min',
                        'description' => 'Create a menu for mobile ordering: "Categories", "Subcategories", and "Products" in the three-level menu. Also, if you want to add modifiers for products, create the modifiers first. To create modifiers, create "Mod Class", then "Modifiers". Finally, select "Mod Class" in the product to add modifiers.',
                        'tracking_title' => 'Mobile order menu',
                        'url' => '',
                        'done' => 'false',
                        'dismissable' => false,
                        'state' => 'state-disabled',
                        'required' => array(
                            'mobileorder_setting' => array(
                                'key' => 'done',
                                'compare' => 'equal',
                                'value' => 'true'
                            ),
                        ),
                        'alternative_url' => '{{token_brand}}/dashboard/location/{{location_uuid}}/shop/{{online_shop_uuid}}/product/product/',
                    )
                )
            ),
            'mobileorder_createbutton' => array(
                'title' => 'Create mobile order button codes',
                'preselected' => 'true',
                'todo' => array(
                    'mobileorder_createbutton' => array(
                        'title' => 'Create mobile order button codes',
                        'subtitle' => '1 min',
                        'description' => 'Create a mobile order button code with your favorite style. Once created, copy the embed button code to your homepage and the URL to your SNS link or Google Business.',
                        'tracking_title' => 'Create mobile order button code',
                        'url' => '',
                        'done' => 'false',
                        'dismissable' => false,
                        'state' => 'state-disabled',
                        'required' => array(
                            'mobileorder_menu' => array(
                                'key' => 'done',
                                'compare' => 'equal',
                                'value' => 'true'
                            ),
                        ),
                        'alternative_url' => '{{token}}/home/setup/linkmborder',
                    )
                )
            ),
            'mobileorder_button' => array(
                'title' => 'Add a mobile order button on your page',
                'preselected' => 'true',
                'todo' => array(
                    'mobileorder_button' => array(
                        'title' => 'Add a mobile order button on your page',
                        'subtitle' => '1 min',
                        'description' => 'Add a mobile order button on your page',
                        'tracking_title' => 'Add a mobile order button on your page',
                        'url' => '',
                        'done' => 'false',
                        'dismissable' => false,
                        'state' => 'state-disabled',
                        'required' => array(
                            'mobileorder_createbutton' => array(
                                'key' => 'done',
                                'compare' => 'equal',
                                'value' => 'true'
                            ),
                        )
                    )
                )
            ),
            'pos_setting' => array(
                'title' => 'Pos settings',
                'preselected' => 'true',
                'todo' => array(
                    'pos_setting' => array(
                        'title' => 'Pos settings',
                        'subtitle' => '1 min',
                        'description' => 'Configure POS settings. Change the settings to suit your store, including tax rates, rounding of payments, eat-in/take-out, special taxes, and receipt formatting.',
                        'tracking_title' => 'Pos settings',
                        'url' => '',
                        'done' => 'false',
                        'dismissable' => false,
                        'state' => 'state-disabled',
                        'required' => array(
                            'setup_shopappuser' => array(
                                'key' => 'done',
                                'compare' => 'equal',
                                'value' => 'true'
                            ),
                            'setup_branduser' => array(
                                'key' => 'done',
                                'compare' => 'equal',
                                'value' => 'true'
                            )
                        ),
                        'alternative_url' => '{{token_brand}}/dashboard/location/{{location_uuid}}/shop/{{register_shop_uuid}}/setting/',
                    )
                )
            ),
            'pos_menu' => array(
                'title' => 'Pos menu',
                'preselected' => 'true',
                'todo' => array(
                    'pos_menu' => array(
                        'title' => 'Pos menu',
                        'subtitle' => '1 min',
                        'description' => 'Create a menu for the POS: Create a 3-level menu, "Categories", "Subcategories", and "Products" in that order. Also, if you want to add toppings for products, create the toppings first. To create toppings, create "Topping Class", then "Toppings". Finally, select "Topping Class" in the commodity.',
                        'tracking_title' => 'Pos menu',
                        'url' => '',
                        'done' => 'false',
                        'dismissable' => false,
                        'state' => 'state-disabled',
                        'required' => array(
                            'pos_setting' => array(
                                'key' => 'done',
                                'compare' => 'equal',
                                'value' => 'true'
                            ),
                        ),
                        'alternative_url' => '{{token_brand}}/dashboard/location/{{location_uuid}}/shop/{{register_shop_uuid}}/product/product/',
                    )
                )
            ),
            'staff_role' => array(
                'title' => 'Create role groups with permissions for staffs',
                'preselected' => 'true',
                'todo' => array(
                    'staff_role' => array(
                        'title' => 'Create role groups with permissions for staffs',
                        'subtitle' => '1 min',
                        'description' => 'Create role groups for staff on the store application. Set permissions for each function in the role group. Assign each staff member a role group with permissions set.',
                        'tracking_title' => 'Create role groups with permissions for staffs',
                        'url' => '',
                        'done' => 'false',
                        'dismissable' => false,
                        'state' => 'state-disabled',
                        'required' => array(
                            'setup_shopappuser' => array(
                                'key' => 'done',
                                'compare' => 'equal',
                                'value' => 'true'
                            ),
                            'setup_branduser' => array(
                                'key' => 'done',
                                'compare' => 'equal',
                                'value' => 'true'
                            )
                        ),
                        'alternative_url' => '{{token_brand}}/dashboard/location/{{location_uuid}}/shop/{{register_shop_uuid}}/employee/role/',
                    )
                )
            ),
            'staff_create' => array(
                'title' => 'Create Staff',
                'preselected' => 'true',
                'todo' => array(
                    'staff_create' => array(
                        'title' => 'Create Staff',
                        'subtitle' => '1 min',
                        'description' => 'Create staff and assign PINs and permission groups.',
                        'tracking_title' => 'Create Staff',
                        'url' => '',
                        'done' => 'false',
                        'dismissable' => false,
                        'state' => 'state-disabled',
                        'required' => array(
                            'staff_role' => array(
                                'key' => 'done',
                                'compare' => 'equal',
                                'value' => 'true'
                            ),
                        ),
                        'alternative_url' => '{{token_brand}}/dashboard/location/{{location_uuid}}/shop/{{register_shop_uuid}}/employee/employee/',
                    )
                )
            ),

            // 'opening_hours_widget' => array(
            //     'title' => 'Opening Hours Widget',
            //     'preselected' => 'true',
            //     'todo' => array(
            //         'opening_hours_widget' => array(
            //             'title' => 'Add an opening hours section on a page',
            //             'subtitle' => '1 min',
            //             'tracking_title' => 'Opening Hours Widget',
            //             'url' => '',
            //             'done' => 'false',
            //             'dismissable' => true,
            //             'state' => 'state-disabled',
            //             'required' => array(
            //                 'setup_menu' => array(
            //                     'key' => 'done',
            //                     'compare' => 'equal',
            //                     'value' => 'true'
            //                 )
            //             )
            //         )
            //     )
            // ),
            // 'kickstart' => array(
            //     'title' => 'Kick-start ordering',
            //     'preselected' => 'true',
            //     'todo' => array(
            //         'first_promo' => array(
            //             'title' => 'Encourage first order',
            //             'subtitle' => '3 min',
            //             'tracking_title' => 'Encourage first order',
            //             'url' => '',
            //             'done' => 'false',
            //             'dismissable' => true,
            //             'state' => 'state-disabled',
            //             'required' => array(
            //                 'setup_menu' => array(
            //                     'key' => 'done',
            //                     'compare' => 'equal',
            //                     'value' => 'true'
            //                 )
            //             ),
            //             'alternative_url' => '{{token}}&parent_window=wordpress&r=app.admin.kickstarter.encourage.overview&hide_top_menu=true&hide_left_menu=true&acid={{acc_id}}'
            //         ),
            //         'promotion' => array(
            //             'title' => 'Advertise with flyers',
            //             'subtitle' => '5 min',
            //             'tracking_title' => 'Advertise with flyers',
            //             'url' => '',
            //             'done' => 'false',
            //             'dismissable' => true,
            //             'state' => 'state-disabled',
            //             'required' => array(
            //                 'setup_menu' => array(
            //                     'key' => 'done',
            //                     'compare' => 'equal',
            //                     'value' => 'true'
            //                 )
            //             ),
            //             'alternative_url' => '{{token}}&parent_window=wordpress&r=app.admin.kickstarter.flyers.overview&hide_top_menu=true&hide_left_menu=true&acid={{acc_id}}'
            //         ),
            //         'invitations' => array(
            //             'title' => 'Invite clients to order online',
            //             'subtitle' => '7 min',
            //             'tracking_title' => 'Invitations',
            //             'url' => '',
            //             'done' => 'false',
            //             'dismissable' => true,
            //             'state' => 'state-disabled',
            //             'required' => array(
            //                 'setup_menu' => array(
            //                     'key' => 'done',
            //                     'compare' => 'equal',
            //                     'value' => 'true'
            //                 )
            //             ),
            //             'alternative_url' => '{{token}}&parent_window=wordpress&r=app.admin.kickstarter.invite_clients.overview&hide_top_menu=true&hide_left_menu=true&acid={{acc_id}}'
            //         )
            //     )
            // ),
            // 'facebook_installation' => array(
            //     'title' => 'Facebook Ordering',
            //     'preselected' => 'true',
            //     'todo' => array(
            //         'facebook_installation' => array(
            //             'title' => 'Add Facebook Order Button',
            //             'subtitle' => '2 min',
            //             'tracking_title' => 'Facebook Installation',
            //             'url' => '',
            //             'done' => 'false',
            //             'dismissable' => true,
            //             'state' => 'state-disabled',
            //             'required' => array(
            //                 'setup_brand_location' => array(
            //                     'key' => 'done',
            //                     'compare' => 'equal',
            //                     'value' => 'true'
            //                 ),
            //                 'setup_menu' => array(
            //                     'key' => 'done',
            //                     'compare' => 'equal',
            //                     'value' => 'true'
            //                 )
            //             ),
            //             'alternative_url' => '{{token}}&parent_window=wordpress&r=app.admin.setup.publishing.facebook_shop_now&hide_top_menu=true&hide_left_menu=true&acid={{acc_id}}'
            //         )
            //     )
            // ),
            'mobileorder_onlinepayment' => array(
                'title' => 'Upgrade and enable online payment for mobile orders',
                'paid' => 'true',
                'todo' => array(
                    'mobileorder_onlinepayment' => array(
                        'title' => 'Upgrade and enable online payment for mobile orders',
                        'subtitle' => '2 min',
                        'description' => '',
                        'tracking_title' => 'Upgrade and enable online payment for mobile orders',
                        'url' => '',
                        'done' => 'false',
                        'dismissable' => false,
                        'paid' => 'true',
                        'subscription_start' => 'subscribe_mobile_payment_',
                        'state' => 'state-disabled',
                        'required' => array(
                            'setup_shopappuser' => array(
                                'key' => 'done',
                                'compare' => 'equal',
                                'value' => 'true'
                            ),
                            'setup_branduser' => array(
                                'key' => 'done',
                                'compare' => 'equal',
                                'value' => 'true'
                            )
                        ),
                        'alternative_url' => '{{token}}/home/setup/purchase',
                    )
                )
            ),
            'reservation_customersite' => array(
                'title' => 'Customer reservation site',
                'paid' => 'true',
                'todo' => array(
                    'reservation_customersite' => array(
                        'title' => 'Upgrade and enable customer reservation site',
                        'subtitle' => '2 min',
                        'description' => '',
                        'tracking_title' => 'Customer reservation site',
                        'url' => '',
                        'done' => 'false',
                        'dismissable' => false,
                        'paid' => 'true',
                        'subscription_start' => 'subscribe_rsvn_cussite_',
                        'state' => 'state-disabled',
                        'required' => array(
                            'setup_shopappuser' => array(
                                'key' => 'done',
                                'compare' => 'equal',
                                'value' => 'true'
                            ),
                            'setup_branduser' => array(
                                'key' => 'done',
                                'compare' => 'equal',
                                'value' => 'true'
                            )
                        ),
                        'alternative_url' => '{{token}}/home/setup/purchase',
                    )
                )
            ),
            // 'autopilot' => array(
            //     'title' => 'Autopilot Marketing Campaign',
            //     'paid' => 'true',
            //     'todo' => array(
            //         'autopilot' => array(
            //             'title' => 'Enable & Configure Autopilot',
            //             'subtitle' => '4 min',
            //             'tracking_title' => 'Autopilot',
            //             'url' => '',
            //             'done' => 'false',
            //             'dismissable' => true,
            //             'paid' => 'true',
            //             'state' => 'state-disabled',
            //             'required' => array(
            //                 'setup_menu' => array(
            //                     'key' => 'done',
            //                     'compare' => 'equal',
            //                     'value' => 'true'
            //                 )
            //             ),
            //             'alternative_url' => '{{token}}&parent_window=wordpress&r=app.admin.autopilot.autopilot.overview&hide_top_menu=true&hide_left_menu=true&acid={{acc_id}}'
            //         )
            //     )
            // ),
            // 'enroll_partner_program' => array(
            //     'title' => 'I am setting up for somebody else',
            //     'todo' => array(
            //         'enroll_partner_program' => array(
            //             'title' => 'Enroll into Partner Program',
            //             'subtitle' => '5 min',
            //             'url' => '',
            //             'done' => 'false',
            //             'dismissable' => true,
            //             'state' => 'state-disabled',
            //             'required' => array(
            //                 'connect_account' => array(
            //                     'key' => 'done',
            //                     'compare' => 'equal',
            //                     'value' => 'true'
            //                 )
            //             ),
            //             'alternative_url' => 'https://langing.as3.monoedge.ai/top/resources/partner-program'
            //         )
            //     )
            // )
        );

        public static $demo_page_title ='How to use MonoEdge widgets';

        public static function get_to_do_options() {
            self::$_token = Monoedge_Utils::$_MONOEDGE->get_monoedge_token();
            self::$_language = self::get_language_code();

            $available_options = self::$_default_options['todo'];

            foreach ( self::$_default_options[ 'todo' ] as $default_todo_key => $default_todo ){
                $available_options[ $default_todo_key ] = $default_todo;
            }

            if ( Monoedge_Utils::$_MONOEDGE->is_authenticated() ) {
                $setup_options = Monoedge_Utils::monoedge_get_from_wordpress_options( 'setup_options', array() );
                foreach ( self::$_extra_options as $extra_opt_key => $extra_opt_value  ) {
                    foreach ( $extra_opt_value['todo'] as $_todo_extra_key => $_todo_extra ) {
                        $add_to_available = false;
                        if( $_todo_extra_key === 'enroll_partner_program' ){
                            $partner_program = Monoedge_Utils::monoedge_get_from_wordpress_options( 'partner_program', '' );
                            $partner_program_dismiss = Monoedge_Utils::monoedge_get_from_wordpress_options( 'partner_program_dismiss', '' );
                            $add_to_available = ($partner_program === 'yes' && $partner_program_dismiss !== 'yes' );
                        }
                        if ( $add_to_available || ( in_array( $_todo_extra_key, $setup_options, true ) || in_array( $extra_opt_key, $setup_options, true) ) ) {
                            $available_options[ $_todo_extra_key ] = $_todo_extra;
                        }
                    }
                }
            }
            return $available_options;
        }

        public static function set_default_setup_options(){
            $default_setup_options = array();

            foreach ( self::$_default_options[ 'todo' ] as $default_todo_key => $default_todo ) {
                $available_options[ $default_todo_key ] = $default_todo;
            }

            if ( Monoedge_Utils::$_MONOEDGE->is_authenticated() ) {
                foreach ( self::$_extra_options as $extra_opt ) {
                    foreach ( $extra_opt[ 'todo' ] as $_todo_extra_key => $_todo_extra ) {
                        if( self::kickstart_and_autopilot_display_check_setup( $_todo_extra_key ) ){
                            $default_setup_options[] = $_todo_extra_key;
                        }
                    }
                }
            }
            Monoedge_Utils::monoedge_add_to_wordpress_options( 'setup_options', $default_setup_options );
        }
        public static function get_verified_available_options( $location = null ) {
            $available_options = self::get_to_do_options();
            $location = ($location === null) ? self::get_default_location() : $location;

            foreach ($available_options as $key => &$option){
                $option = self::monoedge_set_option_state( $option, $available_options, $location );

                if( isset( $option['paid'] ) ){
                    $option = self::check_option_payed_subscription( $key, $option, $location );
                } else {
                    if ( method_exists( Monoedge_Helper_Screens::class, 'check_option_' . $key ) ) {
                        $option = self::{'check_option_' . $key}( $key, $option, $location );
                    } else {
                        $option[ 'done' ] = Monoedge_Utils::monoedge_get_from_wordpress_options( $key, 'false' );
                    }
                }
            }
            return $available_options;
            
        }

        public static function get_default_location(){
            if ( !Monoedge_Utils::$_MONOEDGE->is_authenticated() ) {
                return null;
            }
            $location = array();
            $monoedge_wordpress_options = Monoedge_Utils::monoedge_wp_options_data();
            if( isset( $monoedge_wordpress_options->{'app_options'}[ Monoedge_Utils::$_MONOEDGE->user['user']['id'] ][ 'default_location' ] )  ){
                $location_uuid = Monoedge_Utils::monoedge_get_from_wordpress_options( 'default_location', '' );
                if( !empty( $location_uuid ) ){
                    $location = Monoedge_Utils::get_location_data_by_location_uuid( $location_uuid );
                }
            } else {
                $locations = Monoedge_Utils::monoedge_get_locations();
                if ( is_array( $locations ) && count( $locations ) >= 1 ) {
                    $location = $locations[ 0 ];
                }
            }
            return $location;
        }

        public static function get_user(){
            if ( !Monoedge_Utils::$_MONOEDGE->is_authenticated() ) {
                return null;
            }
            $user = Monoedge_Utils::monoedge_get_user();
            // $monoedge_wordpress_options = Monoedge_Utils::monoedge_wp_options_data();
            // if( isset( $monoedge_wordpress_options->{'app_options'}[ Monoedge_Utils::$_MONOEDGE->user['user']['id'] ][ 'default_location' ] )  ){
            //     $location = Monoedge_Utils::monoedge_get_from_wordpress_options( 'default_location', '' );
            //     if( !empty( $location ) ){
            //         $location = Monoedge_Utils::get_location_data_by_location_uuid( $location );
            //     }

            // }
            return $user;
        }

        

        public static function monoedge_set_option_state( $option, $all_options ){
            $valid = true;
            if( isset( $option[ 'required' ] ) ){
                foreach ( $option[ 'required' ] as $option_name => $condition ){
                    if( isset( $all_options[ $option_name ], $all_options[ $option_name ][ $condition[ 'key' ] ] ) ){
                        $required = $all_options[ $option_name ][ $condition[ 'key' ] ];
                        if( $condition[ 'compare' ] === 'equal' ){
                            if( $required !== $condition[ 'value' ] ){
                                $valid = false;
                            }
                        }

                    }
                }
                if( $valid ){
                    $option[ 'state' ] = 'state-active';
                }
            }
            else{
                $option[ 'state' ] = 'state-active';
            }

            return $option;
        }
        public static function update_option_state( $option ){
            if( $option[ 'done' ] === 'true' ){
                $option[ 'state' ] = 'state-disabled';
            }
            return $option;
        }
        public static function get_extra_options(){
            return self::$_extra_options;
        }
        public static function kickstart_and_autopilot_display_check_setup( $option_name, $location = null ){
            $valid = true;
            $location = ( is_null( $location ) ) ? self::get_default_location() : $location;
            // $total_clients =  $location->total_clients;
            // if ( $total_clients >= self::RESTAURANT_TOTAL_CLIENTS && ( $option_name === 'kickstart' || $option_name === 'first_promo' || $option_name === 'promotion' || $option_name === 'invitations') ) {
            //     $valid = false;
            // } else if ( $total_clients < self::RESTAURANT_TOTAL_CLIENTS && $option_name === 'autopilot' ) {
            //     $valid = false;
            // }
            return $valid;
        }
        public static function get_todo_options_of_extra_option( $key ){
            return isset( self::$_extra_options[ $key ], self::$_extra_options[ $key ]['todo'] ) ? self::$_extra_options[ $key ][ 'todo' ] : '';
        }
        
        public static function get_to_do_text_for_translation( $todo_key, $key ){
            
            $min =  __( ' min', 'menu-ordering-reservations' );
           
            if( $todo_key === 'connect_account' ){

                switch ( $key ) {
                    case 'title':
                        return esc_attr_e( 'Connect to MonoEdge Account', 'monoedge-restaurant-system' );
                        break;
                    case 'sub':
                        return '1' . $min;
                        break;
                    case 'description':
                        return '';
                        break;
                    default:
                        return '';
                        break;
                }
            }
            else if( $todo_key === 'select_server' ){

                switch ( $key ) {
                    case 'title':
                        return esc_attr_e( 'Select a Server', 'monoedge-restaurant-system' );
                        break;
                    case 'sub':
                        return '1' . $min;
                        break;
                    case 'description':
                        return '';
                        break;
                    default:
                        return '';
                        break;
                }

            }
            else if( $todo_key === 'setup_brand_location' ){

                switch ( $key ) {
                    case 'title':
                        return esc_attr_e( 'Setup Brand/Store Profile', 'monoedge-restaurant-system' );
                        break;
                    case 'sub':
                        return '5' . $min;
                        break;
                    case 'description':
                        return '';
                        break;
                    default:
                        return '';
                        break;
                }

            }
            else if( $todo_key === 'setup_shopappuser' ){

                switch ( $key ) {
                    case 'title':
                        return esc_attr_e( 'Shop Application User Creation', 'monoedge-restaurant-system' );
                        break;
                    case 'sub':
                        return '1' . $min;
                        break;
                    case 'description':
                        return '';
                        break;
                    default:
                        return '';
                        break;
                }

            }
            else if( $todo_key === 'setup_branduser' ){

                switch ( $key ) {
                    case 'title':
                        return esc_attr_e( 'Back Office Application User Creation', 'monoedge-restaurant-system' );
                        break;
                    case 'sub':
                        return '1' . $min;
                        break;
                    case 'description':
                        return '';
                        break;
                    default:
                        return '';
                        break;
                }

            }


            else if( $todo_key === 'general_setting' ){

                switch ( $key ) {
                    case 'title':
                        return esc_attr_e( 'General settings', 'monoedge-restaurant-system' );
                        break;
                    case 'sub':
                        return '1' . $min;
                        break;
                    case 'description':
                        return esc_attr_e( 'Set up general settings for your store. Change the settings to suit your store, including tax rates, rounding of payments, eat-in/take-out, special taxes, and receipt formatting adn so on.', 'monoedge-restaurant-system' );
                        break;
                    default:
                        return '';
                        break;
                }

            }
            else if( $todo_key === 'reservation_setting' ){

                switch ( $key ) {
                    case 'title':
                        return esc_attr_e( 'Reservation settings', 'monoedge-restaurant-system' );
                        break;
                    case 'sub':
                        return '1' . $min;
                        break;
                    case 'description':
                        return esc_attr_e( 'Configure reservation settings. Change reservation tag color schemes, create custom tags, set rules for accepting reservations, create courses, set display settings in the store app, and other settings appropriate for your store.', 'monoedge-restaurant-system' );
                        break;
                    default:
                        return '';
                        break;
                }

            }
            else if( $todo_key === 'reservation_businesshours' ){

                switch ( $key ) {
                    case 'title':
                        return esc_attr_e( 'Reservation business hours', 'monoedge-restaurant-system' );
                        break;
                    case 'sub':
                        return '2' . $min;
                        break;
                    case 'description':
                        return esc_attr_e( 'Set hours of operation, lunch seating hours, dinner seating hours, holidays, etc.', 'monoedge-restaurant-system' );
                        break;
                    default:
                        return '';
                        break;
                }

            }
            else if( $todo_key === 'reservation_table' ){

                switch ( $key ) {
                    case 'title':
                        return esc_attr_e( 'Reservation table setting', 'monoedge-restaurant-system' );
                        break;
                    case 'sub':
                        return '3' . $min;
                        break;
                    case 'description':
                        return esc_attr_e( 'Set up all tables in the store. Set up the smallest unit, since they can be linked together.', 'monoedge-restaurant-system' );
                        break;
                    default:
                        return '';
                        break;
                }

            }
            else if( $todo_key === 'reservation_layout' ){

                switch ( $key ) {
                    case 'title':
                        return esc_attr_e( 'Reservation table layout', 'monoedge-restaurant-system' );
                        break;
                    case 'sub':
                        return '3' . $min;
                        break;
                    case 'description':
                        return esc_attr_e( 'Create table layouts. It also joins tables that can be joined together to create a multi-table. Multi-tables are used to accept group reservations.', 'monoedge-restaurant-system' );
                        break;
                    default:
                        return '';
                        break;
                }

            }
            else if( $todo_key === 'reservation_businessdays' ){

                switch ( $key ) {
                    case 'title':
                        return esc_attr_e( 'Reservation business days', 'monoedge-restaurant-system' );
                        break;
                    case 'sub':
                        return '2' . $min;
                        break;
                    case 'description':
                        return esc_attr_e( 'Turn ON the business day on which you wish to accept reservations. This is turned on manually to ensure that the business day is correct.', 'monoedge-restaurant-system' );
                        break;
                    default:
                        return '';
                        break;
                }

            }
            else if( $todo_key === 'reservation_createbutton' ){

                switch ( $key ) {
                    case 'title':
                        return esc_attr_e( 'Create reservation button codes', 'monoedge-restaurant-system' );
                        break;
                    case 'sub':
                        return '1' . $min;
                        break;
                    case 'description':
                        return esc_attr_e( 'Create the reservation button code in the style of your choice. Once created, copy the embed button code to your homepage and the URL to your SNS link or Google Business.', 'monoedge-restaurant-system' );
                        break;
                    default:
                        return '';
                        break;
                }

            }
            else if( $todo_key === 'reservation_button' ){

                switch ( $key ) {
                    case 'title':
                        return esc_attr_e( 'Add a reservations button on your page', 'monoedge-restaurant-system' );
                        break;
                    case 'sub':
                        return '1' . $min;
                        break;
                    case 'description':
                        return esc_attr_e( 'Add a reservations button on your page', 'monoedge-restaurant-system' );
                        break;
                    default:
                        return '';
                        break;
                }

            }
            else if( $todo_key === 'mobileorder_setting' ){

                switch ( $key ) {
                    case 'title':
                        return esc_attr_e( 'Mobile order settings', 'monoedge-restaurant-system' );
                        break;
                    case 'sub':
                        return '1' . $min;
                        break;
                    case 'description':
                        return esc_attr_e( 'Configure the settings for mobile ordering. Set up the settlement method, mobile ordering application appearance, fonts, images, order rules, cancellation rules, sales limits, inventory, etc. as appropriate for your store.', 'monoedge-restaurant-system' );
                        break;
                    default:
                        return '';
                        break;
                }

            }
            else if( $todo_key === 'mobileorder_menu' ){

                switch ( $key ) {
                    case 'title':
                        return esc_attr_e( 'Mobile order menu', 'monoedge-restaurant-system' );
                        break;
                    case 'sub':
                        return '1' . $min;
                        break;
                    case 'description':
                        return esc_attr_e( 'Create a menu for mobile ordering: "Categories", "Subcategories", and "Products" in the three-level menu. Also, if you want to add modifiers for products, create the modifiers first. To create modifiers, create "Mod Class", then "Modifiers". Finally, select "Mod Class" in the product to add modifiers.', 'monoedge-restaurant-system'  );
                        break;
                    default:
                        return '';
                        break;
                }

            }
            else if( $todo_key === 'mobileorder_createbutton' ){

                switch ( $key ) {
                    case 'title':
                        return esc_attr_e( 'Create mobile order button codes', 'monoedge-restaurant-system' );
                        break;
                    case 'sub':
                        return '1' . $min;
                        break;
                    case 'description':
                        return esc_attr_e( 'Create a mobile order button code with your favorite style. Once created, copy the embed button code to your homepage and the URL to your SNS link or Google Business.', 'monoedge-restaurant-system'  );
                        break;
                    default:
                        return '';
                        break;
                }

            }
            else if( $todo_key === 'mobileorder_button' ){

                switch ( $key ) {
                    case 'title':
                        return esc_attr_e( 'Add a mobile order button on your page', 'monoedge-restaurant-system' );
                        break;
                    case 'sub':
                        return '1' . $min;
                        break;
                    case 'description':
                        return esc_attr_e( 'Add a mobile order button on your page', 'monoedge-restaurant-system'  );
                        break;
                    default:
                        return '';
                        break;
                }

            }
            else if( $todo_key === 'pos_setting' ){

                switch ( $key ) {
                    case 'title':
                        return esc_attr_e( 'Pos settings', 'monoedge-restaurant-system' );
                        break;
                    case 'sub':
                        return '1' . $min;
                        break;
                    case 'description':
                        return esc_attr_e( 'Configure POS settings. Change the settings to suit your store, including tax rates, rounding of payments, eat-in/take-out, special taxes, and receipt formatting.', 'monoedge-restaurant-system'  );
                        break;
                    default:
                        return '';
                        break;
                }

            }
            else if( $todo_key === 'pos_menu' ){

                switch ( $key ) {
                    case 'title':
                        return esc_attr_e( 'Pos menu', 'monoedge-restaurant-system' );
                        break;
                    case 'sub':
                        return '1' . $min;
                        break;
                    case 'description':
                        return esc_attr_e( 'Create a menu for the POS: Create a 3-level menu, "Categories", "Subcategories", and "Products" in that order. Also, if you want to add toppings for products, create the toppings first. To create toppings, create "Topping Class", then "Toppings". Finally, select "Topping Class" in the commodity.', 'monoedge-restaurant-system'  );
                        break;
                    default:
                        return '';
                        break;
                }

            }
            else if( $todo_key === 'staff_role' ){

                switch ( $key ) {
                    case 'title':
                        return esc_attr_e( 'Create role groups with permissions for staffs', 'monoedge-restaurant-system' );
                        break;
                    case 'sub':
                        return '1' . $min;
                        break;
                    case 'description':
                        return esc_attr_e( 'Create role groups for staff on the store application. Set permissions for each function in the role group. Assign each staff member a role group with permissions set.', 'monoedge-restaurant-system'  );
                        break;
                    default:
                        return '';
                        break;
                }

            }
            else if( $todo_key === 'staff_create' ){

                switch ( $key ) {
                    case 'title':
                        return esc_attr_e( 'Create Staff', 'monoedge-restaurant-system' );
                        break;
                    case 'sub':
                        return '1' . $min;
                        break;
                    case 'description':
                        return esc_attr_e( 'Create staff and assign PINs and permission groups.', 'monoedge-restaurant-system'  );
                        break;
                    default:
                        return '';
                        break;
                }

            }
            else if( $todo_key === 'mobileorder_onlinepayment' ){

                switch ( $key ) {
                    case 'title':
                        return esc_attr_e( 'Upgrade and enable online payment for mobile orders', 'monoedge-restaurant-system' );
                        break;
                    case 'sub':
                        return '2' . $min;
                        break;
                    case 'description':
                        return '';
                        break;
                    default:
                        return '';
                        break;
                }

            }
            else if( $todo_key === 'reservation_customersite' ){

                switch ( $key ) {
                    case 'title':
                        return esc_attr_e( 'Upgrade and enable customer reservation site', 'monoedge-restaurant-system' );
                        break;
                    case 'sub':
                        return '2' . $min;
                        break;
                    case 'description':
                        return '';
                        break;
                    default:
                        return '';
                        break;
                }

            }

            return '';
        }

        public static function generate_todo_list( $location = null ){
            
            global $allowed_html;
            ob_start();
            $todo_options = Monoedge_Helper_Screens::get_verified_available_options( $location );
            $previous_completed = 'false';
            foreach ($todo_options as $todo_key =>  $todo){
                if ( isset( $todo[ 'custom_link' ] ) ) {
                    echo wp_kses( $todo[ 'custom_link' ], $allowed_html );
                } else{
                    echo wp_kses( $todo[ 'url' ], $allowed_html );
                }

            ?>
                <span class="icon"></span>
                <span class="desc flx-col">
                    <span class="title"><?php echo esc_attr( self::get_to_do_text_for_translation( $todo_key, 'title' ) ); ?></span>
                    <span class="sub"><?php echo esc_attr( self::get_to_do_text_for_translation( $todo_key, 'sub' ) ); ?></span>
                    <span class="description"><?php echo esc_attr( self::get_to_do_text_for_translation( $todo_key, 'description' ) ); ?></span>
                </span>
                <span class="flx-right">
                    <?php
                    if ( $todo[ 'dismissable' ] ) {
                        ?>
                        <span class="dismiss monoedge-button-action" data-id="<?php echo esc_attr( $todo_key ); ?>" data-action="option_dismiss"><?php esc_attr_e( 'Dismiss', 'monoedge-restaurant-system' ); ?></span>
                        <?php
                    }
                    ?>
                    <?php
                    if ( $todo_key !== 'connect_account' && $previous_completed !== 'true' ) {
                        ?>
                        <span class="icon-info">
                            <span class="info-tooltip"><?php esc_attr_e( 'You have to complete the previous step before doing this one.', 'monoedge-restaurant-system' ); ?></span>
                        </span>
                        <?php
                    }
                    ?>
                </span>
            </a>
            <?php
                $previous_completed = $todo[ 'done' ];
            }
            return ob_get_clean();
        }


        public static function create_demo_page(){
            // if( get_page_by_title( self::$demo_page_title ) === NULL ){
            if( self::new_get_page_by_title( self::$demo_page_title ) === NULL ){
                
                // $page_content = '<!-- wp:heading -->';
                // $page_content .= '<h2>' . __( 'How to use MonoEdge widgets', 'monoedge-restaurant-system' ) . '</h2>';
                // $page_content .= '<!-- /wp:heading -->';

                $page_content = '<!-- wp:heading {"level":3} -->';
                $page_content .= '<h3 class="monoedge-wp-block-heading" >' . __( 'Let\'s add a Reservation button', 'monoedge-restaurant-system' ) . '</h3>';
                $page_content .= '<!-- /wp:heading -->';
                $page_content .= '<!-- wp:paragraph -->';
                $page_content .= '<h5 class="monoedge-wp-block-heading-subtitle" > ' . __( 'Click \'Type / to choose a block\' below, click \'+\' buttom, search and choose \'Custom HTML\' and then copy created personalized HTML Button code from Admin management site.', 'monoedge-restaurant-system' ) . '</h5>';
                $page_content .= '<!-- /wp:paragraph -->';
                
                $page_content .= '<!-- wp:paragraph -->';
                $page_content .= '<p></p>';
                $page_content .= '<!-- /wp:paragraph -->';

                $page_content .= '<!-- wp:heading {"level":3} -->';
                $page_content .= '<h3 class="monoedge-wp-block-heading">' . __( 'Let\'s add a Mobile Ordering button', 'monoedge-restaurant-system' ) . '</h3>';
                $page_content .= '<!-- /wp:heading -->';
                $page_content .= '<!-- wp:paragraph -->';
                $page_content .= '<h5 class="monoedge-wp-block-heading-subtitle"> ' . __( 'Click \'Type / to choose a block\' below, click \'+\' button on right side, search and choose \'Custom HTML\' and then copy created personalized HTML Button code from Admin management site.', 'monoedge-restaurant-system' ) . '</h5>';
                $page_content .= '<!-- /wp:paragraph -->';

                $page_content .= '<!-- wp:paragraph -->';
                $page_content .= '<p></p>';
                $page_content .= '<!-- /wp:paragraph -->';

                // $page_content .= '<!-- wp:heading {"level":3} -->';
                // $page_content .= '<h3>' . __( 'Now let\'s add the Menu widget', 'monoedge-restaurant-system' ) . '</h3>';
                // $page_content .= '<!-- /wp:heading -->';

                // $page_content .= '<!-- wp:paragraph -->';
                // $page_content .= '<p></p>';
                // $page_content .= '<!-- /wp:paragraph -->';

                // $page_content .= '<!-- wp:heading {"level":3} -->';
                // $page_content .= '<h3>' . __( 'Finally let\'s add the Opening Hours widget', 'monoedge-restaurant-system' ) . '</h3>';
                // $page_content .= '<!-- /wp:heading -->';

                // $page_content .= '<!-- wp:paragraph -->';
                // $page_content .= '<p></p>';
                // $page_content .= '<!-- /wp:paragraph -->';

                $demo_page_details = array(
                    'post_title' => self::$demo_page_title,
                    'post_content' => $page_content,
                    'post_name' => 'how-to-use-MonoEdge-widgets',
                    'post_status' => 'draft',
                    'post_author' => 1,
                    'post_type' => 'page'
                );
                wp_insert_post( $demo_page_details );
            }
        }

        public static function get_demo_page_edit_url(){
            // $demo_page = get_page_by_title( self::$demo_page_title );
            $demo_page = self::new_get_page_by_title( self::$demo_page_title );
            return is_null( $demo_page ) ? '#' : admin_url() . 'post.php?post=' . $demo_page->ID . '&action=edit';
        }

        public static function check_option_connect_account( $key, $option, $location ){
            $option[ 'done' ] = Monoedge_Utils::$_MONOEDGE->is_authenticated() ? 'true' : 'false';

            $option = self::update_option_state( $option );

            $option[ 'url' ] = '<a id="' . $key . '" href="' . ( !Monoedge_Utils::$_MONOEDGE->is_authenticated() ? admin_url() . 'admin.php?page=monoedge-screens' : '#' ) . '" ';
            $option[ 'url' ] .= 'class="monoedge-list-item  monoedge-button-action ' . $option[ 'state' ] . '" data-action="monoedge_load_screen" data-screen="overview_authenticate" ';
            $option[ 'url' ] .= 'data-completed="' . $option[ 'done' ] . '"';
            if ( isset( $option[ 'tracking_title' ] ) ) {
                $option[ 'url' ] .= ' data-title="' . $option[ 'tracking_title' ] . '"';
            }
            $option[ 'url' ] .= '>';

            return $option;
        }

        // public static function check_option_test_redirect( $key, $option, $location ){
        //     $completed_screens = array(
        //         'app.admin.setup.menu_app.menu_editor'
        //     );
        //     $location_completed_screens_admin  = ( empty( $location->completed_screens_admin) ? array() : $location->completed_screens_admin );
        //     if ( $location !== null && count($location) > 0) {
        //         $option[ 'done' ] = ( empty( array_diff( $completed_screens, $location_completed_screens_admin ) ) || $location->setup_completed_admin )? 'true' : 'false';
        //     }

        //     $option = self::update_option_state( $option );

        //     return self::set_alternative_flow_url( $key, $option, $location );
        // }

        
        public static function check_option_select_server( $key, $option, $location ){
            if( Monoedge_Utils::$_MONOEDGE->is_authenticated() ){
                $option[ 'done' ] = self::is_done_select_server( $location ) ? 'true' : 'false';
            }

            $option = self::update_option_state( $option );
            return self::set_alternative_flow_url( $key, $option, $location );
        }
        public static function check_option_setup_brand_location( $key, $option, $location ){
            if( Monoedge_Utils::$_MONOEDGE->is_authenticated() ){
                $option[ 'done' ] = self::is_done_setup_brand_location( $location ) ? 'true' : 'false';
            }

            $option = self::update_option_state( $option );
            return self::set_alternative_flow_url( $key, $option, $location );
        }
        
        public static function check_option_setup_shopappuser( $key, $option, $location ){
            if( Monoedge_Utils::$_MONOEDGE->is_authenticated() ){
                $option[ 'done' ] = self::is_done_setup_shopappuser( $location ) ? 'true' : 'false';
            }
            $option = self::update_option_state( $option );
            return self::set_alternative_flow_url( $key, $option, $location );
        }
        
        public static function check_option_setup_branduser( $key, $option, $location ){
            if( Monoedge_Utils::$_MONOEDGE->is_authenticated() ){
                $option[ 'done' ] = self::is_done_setup_branduser( $location ) ? 'true' : 'false';
            }
            $option = self::update_option_state( $option );
            return self::set_alternative_flow_url( $key, $option, $location );
        }

        public static function is_done_select_server(){
            $_user = Monoedge_Utils::monoedge_get_user();
            $_server_id = $_user['server_id'];
            if ( isset($_server_id) ) {
                if ( $_server_id > 0 ) {
                    return true;
                }
            } 
            return false;            
        }
        public static function is_done_setup_brand_location( $location = null ){
            // $completed_screens = array(
            //     'app.admin.setup.basics.address_form',
            //     'app.admin.setup.basics.address_location',
            //     'app.admin.setup.basics.cuisines',
            //     'app.admin.setup.basics.email',
            //     'app.admin.setup.basics.restaurant_website',
            //     'app.admin.setup.hours.delivery',
            //     'app.admin.setup.hours.open_hours',
            //     'app.admin.setup.hours.dine_in',
            //     'app.admin.setup.hours.order_later',
            //     'app.admin.setup.hours.pickup',
            //     'app.admin.setup.hours.table_reservation',
            //     'app.admin.setup.menu_app.alert_call',
            //     'app.admin.setup.menu_app.app_installation',
            //     'app.admin.setup.taxes.payment',
            //     'app.admin.setup.taxes.tax',
            //     'app.admin.setup.taxes.terms'
            // );
            $_user = Monoedge_Utils::monoedge_get_user();
            $_locations = $_user['locations'];
            $_brand = $_user['brand'];
            if ( ( ! ( $_locations === null )) && ( count($_locations) > 0 ) && isset($_brand["brand_name"]) && isset($_brand["brand_url_name"]) ) {
                if ( count($_locations) > 0 ) {
                    return true;
                }
            } 
            return false;
            
        }

        public static function is_done_setup_shopappuser(){
            $_user = Monoedge_Utils::monoedge_get_user();
            $_shopapp_users = $_user['shopapp_users'];
            if ( isset($_shopapp_users) ) {
                if ( count($_shopapp_users) > 0 ) {
                    return true;
                }
            } 
            return false;            
        }
        public static function is_done_setup_branduser(){
            $_user = Monoedge_Utils::monoedge_get_user();
            $_brand_users = $_user['brand_users'];
            if ( isset($_brand_users) ) {
                if ( count($_brand_users) > 0 ) {
                    return true;
                }
            } 
            return false;            
        }
        

        public static function check_option_setup_menu( $key, $option, $location ){
            $completed_screens = array(
                'app.admin.setup.menu_app.menu_editor'
            );
            $location_completed_screens_admin  = ( empty( $location->completed_screens_admin) ? array() : $location->completed_screens_admin );
            if ( $location !== null ) {
                $option[ 'done' ] = ( empty( array_diff( $completed_screens, $location_completed_screens_admin ) ) || $location->setup_completed_admin )? 'true' : 'false';
            }

            $option = self::update_option_state( $option );

            return self::set_alternative_flow_url( $key, $option, $location );
        }
        
        /* Button Ordering App Option */
        public static function check_option_mobileorder_onlinepayment( $key, $option, $location ){
            return self::demo_page_option( $key, $option);
        }
        /* Button Reservations App Option */
        public static function check_option_reservation_customersite( $key, $option, $location ){
            return self::demo_page_option( $key, $option);
        }

        /* Button Ordering App Option */
        // public static function check_option_mobileorder_button( $key, $option, $location ){
        //     return self::demo_page_option( $key,$option);
        // }
        /* Button Ordering App Option */
        public static function check_option_mobileorder_button( $key, $option, $location ){
            return self::demo_page_option( $key,$option, $location);
        }

        /* Button Reservations App Option */
        // public static function check_option_reservation_button( $key, $option, $location ){
        //     return self::demo_page_option( $key, $option, $location );
        // }
        /* Button Reservations App Option */
        public static function check_option_reservation_button( $key, $option, $location ){
            return self::demo_page_option( $key, $option, $location );
        }

        /* Widget Menu App Option */
        // public static function check_option_menu_widget( $key, $option, $location ){
        //     return self::demo_page_option( $key, $option );
        // }

        /* Widget Opening Hours App Option */
        // public static function check_option_opening_hours_widget( $key, $option, $location ){
        //     return self::demo_page_option( $key, $option );
        // }

        public static function demo_page_option( $key, $option, $location = null ){
            // $demo_page = get_page_by_title( self::$demo_page_title );
            $demo_page = self::new_get_page_by_title( self::$demo_page_title );
            
            $button_action = is_null( $demo_page ) ? ' monoedge-button-action-demo-page ' : ' monoedge-button-action ';
            $option[ 'done' ] = Monoedge_Utils::monoedge_get_from_wordpress_options( $key, 'false' );
            // $option[ 'done' ] = Monoedge_Utils::monoedge_check_done_by_website_url( $option[ 'done' ], $location );
            if ( $key=="reservation_button") {
                if ( isset($demo_page->post_content) ) {                
                    $_user = Monoedge_Utils::monoedge_get_user();      
                    if ( str_contains($demo_page->post_content, '#/booking/location/' . $_user["brand"]["brand_url_name"] . '/' . $location['location_url_name'] )) {
                        if ( str_contains($demo_page->post_content, '/reservation-notice/' ) && str_contains($demo_page->post_content, 'https://reservation')) {
                            $option[ 'done' ]  = 'true';
                        }
                    }
                }
            }
            if ( $key=="mobileorder_button") {
                if ( isset($demo_page->post_content) ) {                
                    $_user = Monoedge_Utils::monoedge_get_user();  
                    if ( str_contains($demo_page->post_content, '/v1/' . $_user["brand"]["brand_url_name"] )) {
                        if ( str_contains($demo_page->post_content, 'https://foodmenu')) {
                            $option[ 'done' ]  = 'true';
                        }
                    }
                }
            }


            $option = self::update_option_state( $option );
            $option[ 'url' ] = '<a href="' . ( Monoedge_Utils::$_MONOEDGE->is_authenticated() ? self::get_demo_page_edit_url() : '#' ) . '" class="monoedge-list-item ' . $button_action . $option[ 'state' ] . '" target = "_blank" data-completed="' . $option[ 'done' ] . '"';
            if ( isset( $option[ 'tracking_title' ] ) ) {
                $option[ 'url' ] .= ' data-title="' . $option[ 'tracking_title' ] . '"';
                $option[ 'url' ] .= ' data-completed="' . $option[ 'done' ] . '"';
            }
            $option[ 'url' ] .= '>';
            return $option;






            // if ( isset(self::$_extra_options[$key])) {
            //     $monoedge_wordpress_options = Monoedge_Utils::monoedge_wp_options_data();
            //     $user = Monoedge_Utils::monoedge_get_user();
            //     $location_uuid = $monoedge_wordpress_options->{'app_options'}[ $user['id'] ]['default_location'];
            //     if ( isset( $monoedge_wordpress_options->{'app_options'}[ $location_uuid ]) ){
            //         if ( isset( $monoedge_wordpress_options->{'app_options'}[ $location_uuid ][ 'setup_options_status' ]) ){
            //             if ( isset( $monoedge_wordpress_options->{'app_options'}[ $location_uuid ][ 'setup_options_status' ][ $key ]) ){
            //                 if ( $monoedge_wordpress_options->{'app_options'}[ $location_uuid ][ 'setup_options_status' ][ $key ] == "done" ){
            //                     $option[ 'done' ] = 'true';
            //                 }
            //             }
            //         }
            //     }
            // }
            // return self::set_alternative_flow_url( $key, $option, $location );



        }

        // public static function check_option_facebook_installation( $key, $option, $location ){
        //     return self::check_completed_screens( $key, $option, $location );
        // }

        /* Kick-start Ordering --- first_promo */
        // public static function check_option_first_promo( $key, $option, $location ){
        //     return self::check_completed_screens( $key, $option, $location );
        // }

        /* Kick-start Ordering --- promotion */
        // public static function check_option_promotion( $key, $option, $location ){
        //     return self::check_completed_screens( $key, $option, $location );
        // }

        /* Kick-start Ordering --- invitations */
        // public static function check_option_invitations( $key, $option, $location ){
        //     return self::check_completed_screens( $key, $option, $location );
        // }

        
        /* general_setting */
        public static function check_option_general_setting( $key, $option, $location ){
            return self::check_completed_screens( $key, $option, $location );
        }
        /* reservation_setting */
        public static function check_option_reservation_setting( $key, $option, $location ){
            return self::check_completed_screens( $key, $option, $location );
        }
        /* reservation_businesshours */
        public static function check_option_reservation_businesshours( $key, $option, $location ){
            return self::check_completed_screens( $key, $option, $location );
        }
        /* reservation_businessdays */
        public static function check_option_reservation_businessdays( $key, $option, $location ){
            return self::check_completed_screens( $key, $option, $location );
        }
        /* reservation_table */
        public static function check_option_reservation_table( $key, $option, $location ){
            return self::check_completed_screens( $key, $option, $location );
        }
        /* reservation_layout */
        public static function check_option_reservation_layout( $key, $option, $location ){
            return self::check_completed_screens( $key, $option, $location );
        }
        /* reservation_createbutton */
        public static function check_option_reservation_createbutton( $key, $option, $location ){
            return self::check_completed_screens( $key, $option, $location );
        }
        /* mobileorder_setting */
        public static function check_option_mobileorder_setting( $key, $option, $location ){
            return self::check_completed_screens( $key, $option, $location );
        }
        /* mobileorder_menu */
        public static function check_option_mobileorder_menu( $key, $option, $location ){
            return self::check_completed_screens( $key, $option, $location );
        }
        /* mobileorder_createbutton */
        public static function check_option_mobileorder_createbutton( $key, $option, $location ){
            return self::check_completed_screens( $key, $option, $location );
        }
        /* pos_setting */
        public static function check_option_pos_setting( $key, $option, $location ){
            return self::check_completed_screens( $key, $option, $location );
        }
        /* pos_menu */
        public static function check_option_pos_menu( $key, $option, $location ){
            return self::check_completed_screens( $key, $option, $location );
        }
        /* staff_role */
        public static function check_option_staff_role( $key, $option, $location ){
            return self::check_completed_screens( $key, $option, $location );
        }
        /* staff_create */
        public static function check_option_staff_create( $key, $option, $location ){
            return self::check_completed_screens( $key, $option, $location );
        }

        public static function check_completed_screens( $key, $option, $location ){
            // $completed_screens = array(
            //     'first_promo' => array( 'app.admin.kickstarter.encourage.first_promo' ),
            //     'promotion' => array( 'app.admin.kickstarter.flyers.promotion' ),
            //     'invitations' => array( 'app.admin.kickstarter.invite_clients.invitations' ),
            //     'facebook_installation' => array( 'app.admin.setup.publishing.facebook_shop_now' )
            // );
            if ( isset( $completed_screens[ $key ] ) ) {
                $option[ 'done' ] = empty( array_diff( $completed_screens[$key], $location->completed_screens_admin ) ) ? 'true' : 'false';
            }

            if ( isset(self::$_extra_options[$key])) {
                $monoedge_wordpress_options = Monoedge_Utils::monoedge_wp_options_data();
                $user = Monoedge_Utils::monoedge_get_user();
                $location_uuid = $monoedge_wordpress_options->{'app_options'}[ $user['id'] ]['default_location'];
                if ( isset( $monoedge_wordpress_options->{'app_options'}[ $location_uuid ]) ){
                    if ( isset( $monoedge_wordpress_options->{'app_options'}[ $location_uuid ][ 'setup_options_status' ]) ){
                        if ( isset( $monoedge_wordpress_options->{'app_options'}[ $location_uuid ][ 'setup_options_status' ][ $key ]) ){
                            if ( $monoedge_wordpress_options->{'app_options'}[ $location_uuid ][ 'setup_options_status' ][ $key ] == "done" ){
                                $option[ 'done' ] = 'true';
                            }
                        }
                    }
                }
            }
            return self::set_alternative_flow_url( $key, $option, $location );
        }

        /*
         * Payed Subscription Options Check
         *
         * - ONLINE PAYMENTS
         * - AUTOPILOT
         */
        public static function check_option_payed_subscription( $subscription_name, &$option, $location ){
            $_user = Monoedge_Utils::monoedge_get_user();
            $_subscription = $_user [ 'subscription' ];
            $_subscription_start = $option[ 'subscription_start' ];
            foreach($_subscription as $key => $value) {
                if (stristr($key, $_subscription_start)!==false) {
                    if ( $value["amount"] > 0 ) {
                        $option[ 'done' ] = 'true';
                    }
                }
            }
            // $option[ 'done' ] = empty( array_diff( array( strtoupper( $subscription_name ) ), $location->payed_subscriptions->active ) ) ? 'true' : 'false';   ////////////////////////////
            return self::set_alternative_flow_url( $subscription_name, $option, $location );
        }

        // public static function check_option_enroll_partner_program( $key, $option ) {
        //     $partner_program_clicked = Monoedge_Utils::monoedge_get_from_wordpress_options( 'partner_program_clicked', '' );
        //     $option[ 'done' ] = $partner_program_clicked === 'yes' ? 'true' : 'false';
        //     $option[ 'url' ] = '<a id="' . $key . '"href = "#" class="monoedge-list-item monoedge-button-action ' . $option[ 'state' ] . '" data-screen="overview" data-id="new_tab_link" data-action="monoedge_set_option" data-option="partner_program_clicked" data-value="yes" target="_blank" data-completed="' . $option[ 'done' ] . '"' . ' data-flow-url="' . $option[ 'alternative_url' ] . '" > ';
        //     return $option;
        // }

        public static function set_alternative_flow_url( $key, $option, $location ){
            $baseURL = $option[ 'alternative_url' ];
            $hiddenOption = '';
            // if ( Monoedge_Utils::$_MONOEDGE->is_authenticated() ) {
            //     $baseURL = str_replace(
            //         array( '{{token}}', '{{acc_id}}' ),
            //         array( self::$_token, $location->account_id ),
            //         $baseURL
            //     );
            //     $hiddenOption = (!self::kickstart_and_autopilot_display_check_setup( $key, $location )) ? 'hidden-option' : '';
            // }
            if (str_contains($baseURL, '{{token}}')) { 
                $baseURL = str_replace(
                    array( '{{token}}' ),
                    array( self::$_token ),
                    $baseURL
                );
            }
            if (str_contains($baseURL, '{{token_shopapp}}')) { 
                $_user = Monoedge_Utils::monoedge_get_user();
                $_alternative_token = "";
                if ( str_starts_with($_user["server"]["domain"], '127.0.0.1')) {
                    $_alternative_token = "http://" . explode(":", $_user["server"]["domain"])[0] . ":8080";
                } else {
                    $_alternative_token = "https://shopapp." . $_user["server"]["domain"];
                }
                $baseURL = str_replace(
                    array( '{{token_shopapp}}' ),
                    array( $_alternative_token ),
                    $baseURL
                );
            }
            if (str_contains($baseURL, '{{token_brand}}')) { 
                $_user = Monoedge_Utils::monoedge_get_user();
                $_alternative_token = "";
                if ( str_starts_with($_user["server"]["domain"], '127.0.0.1')) {
                    $_alternative_token = "http://" . explode(":", $_user["server"]["domain"])[0] . ":15000";
                    // $_alternative_token = str_replace("8083", "8080",$_alternative_token);
                } else {
                    $_alternative_token = "https://brand." . $_user["server"]["domain"];
                }
                $baseURL = str_replace(
                    array( '{{token_brand}}' ),
                    array( $_alternative_token ),
                    $baseURL
                );
            }
            if (str_contains($baseURL, '{{location_name}}')) { 
                $_user = Monoedge_Utils::monoedge_get_user();
                $_alternative_token = "";
                $baseURL = str_replace(
                    array( '{{location_name}}' ),
                    array( $location["location_url_name"] ),
                    $baseURL
                );
            }
            if (str_contains($baseURL, '{{location_uuid}}')) { 
                $_user = Monoedge_Utils::monoedge_get_user();
                $_alternative_token = "";
                $baseURL = str_replace(
                    array( '{{location_uuid}}' ),
                    array( $location["location_uuid"] ),
                    $baseURL
                );
            }
            if (str_contains($baseURL, '{{register_shop_uuid}}')) { 
                $_user = Monoedge_Utils::monoedge_get_user();
                $_alternative_token = "";
                $baseURL = str_replace(
                    array( '{{register_shop_uuid}}' ),
                    array( $location["location_shop_uuids"]["Register"]["shop_uuid"] ),
                    $baseURL
                );
            }
            if (str_contains($baseURL, '{{online_shop_uuid}}')) { 
                $_user = Monoedge_Utils::monoedge_get_user();
                $_alternative_token = "";
                $baseURL = str_replace(
                    array( '{{online_shop_uuid}}' ),
                    array( $location["location_shop_uuids"]["Online"]["shop_uuid"] ),
                    $baseURL
                );
            }




            $option[ 'url' ] = '<a id="' . $key . '" href = "#" class="monoedge-list-item monoedge-button-action ' . $option[ 'state' ] . ' ' . $hiddenOption . '" data-id="new_tab_link" data-action="screen_change" target="_parent" ';
            $option[ 'url' ] .= ' data-flow-url="' . $baseURL . '"';
            if( isset( $option['tracking_title'] ) ){
                $option[ 'url' ] .= ' data-title="' . $option[ 'tracking_title' ] . '"';
            }
            $option[ 'url' ] .= ' data-completed="' . $option[ 'done' ] . '">';
            return $option;
        }

        public static function get_language_code() {
            return explode( '_', get_locale() )[ 0 ];
        }

        public static function new_get_page_by_title( $page_title, $output = OBJECT, $post_type = 'page' ) {
            $args  = array(
                'title'                  => $page_title,
                'post_type'              => $post_type,
                'post_status'            => get_post_stati(),
                'posts_per_page'         => 1,
                'update_post_term_cache' => false,
                'update_post_meta_cache' => false,
                'no_found_rows'          => true,
                'orderby'                => 'post_date ID',
                'order'                  => 'ASC',
            );
            $query = new WP_Query( $args );
            $pages = $query->posts;
        
            if ( empty( $pages ) ) {
                return null;
            }
        
            return get_post( $pages[0], $output );
        }

    }
}