<?php
if ( !defined( 'ABSPATH' ) ) {
    exit;
} // Exit if accessed directly

$redirect_screen = '';
if( isset( $_REQUEST[ 'redirect' ] )){

    // Nonce velification
    if (!isset($_REQUEST['ajax_nonce']) || !wp_verify_nonce($_REQUEST['ajax_nonce'], 'monoedge-nonce')) {
        exit('Nonce verification failed');
    }
    $redirect_screen = esc_attr($_REQUEST[ 'redirect' ]);
}
?>


<div id="monoedge-consent" data-consent="<?php echo esc_attr( Monoedge_Utils::monoedge_get_from_wordpress_options( 'share_usage_data', '' ) ); ?>"></div>
<div class="monoedge-wrapper overview" data-redirect="<?php echo esc_attr( $redirect_screen ); ?>">
    <?php
    if(Monoedge_Utils::$_MONOEDGE->is_authenticated() ){
        if ( is_array( Monoedge_Utils::monoedge_get_locations() ) && count( Monoedge_Utils::monoedge_get_locations() ) >= 1 ) {
        ?>
            <div class="monoedge-section flx-col">
                <div class="monoedge-d-flex monoedge-white-box publish" style="padding: 12px 24px; width: 90vw; max-width: 100%;">
                    <?php
                    if ( is_array( Monoedge_Utils::monoedge_get_locations() ) && count( Monoedge_Utils::monoedge_get_locations() ) > 1) {
                    ?>
                    <div class="monoedge-select-label"><?php esc_attr_e('Restaurant', 'monoedge-restaurant-system'); ?></div>
                    <?php
                    }
                    ?>
                    <label for="monoedge_restaurant">
                        <?php
                        $selected_option = '';
                        $custom_css_location = Monoedge_Utils::monoedge_get_from_wordpress_options( 'default_location', '' );

                        if ( isset( $custom_css_location ) ) {
                            $selected_option = $custom_css_location;
                        }
                        if ( is_array( Monoedge_Utils::monoedge_get_locations() ) && count( Monoedge_Utils::monoedge_get_locations() ) > 1 ) {
                            Monoedge_Utils::monoedge_get_locations_dropdown( 'js_monoedge_location_uuid', 'ruid', 'uid', $selected_option, 'MONOEDGE.core.dropdown_change' );
                        } else if ( is_array( Monoedge_Utils::monoedge_get_locations() ) && count( Monoedge_Utils::monoedge_get_locations() ) == 1 ) {
                            ?>
                            <span class="single-restaurant"><?php echo esc_attr( Monoedge_Utils::monoedge_get_locations()[ 0 ]['location_name'] ); ?></span>
                            <input type="hidden" name="ruid" id="js_monoedge_location_uuid" value="<?php echo esc_attr( Monoedge_Utils::monoedge_get_locations()[ 0 ]['location_uuid'] ); ?>">
                            <?php
                        }
                        ?>
                    </label>
                    <?php
                    if ( is_array( Monoedge_Utils::monoedge_get_locations() ) && count( Monoedge_Utils::monoedge_get_locations() ) > 1) {
                    ?>
                    <span class="icon-info">
                        <span class="info-tooltip"><?php esc_attr_e( 'You can change the restaurant for which you want to configure', 'monoedge-restaurant-system' ); ?></span>
                    </span>
                    <?php
                    }
                    ?>
                </div>
            </div>
        <?php
        }
    }
    ?>
    <!-- <div class="monoedge-section monoedge-w-520 monoedge-white-back flx-col"> -->
    <div class="monoedge-section monoedge-white-back flx-col">
        <div class="monoedge-section-header flx-align-space-between">
            <div class="section-title"><?php esc_attr_e( 'TO DO', 'monoedge-restaurant-system' ); ?></div>
            <?php
            if (Monoedge_Utils::$_MONOEDGE->is_authenticated()){
                $location_uuid = Monoedge_Utils::monoedge_get_from_wordpress_options( 'default_location', '' );
                $selected_location = null;
                if ( !empty( $location_uuid ) ) {
                    $selected_location = Monoedge_Utils::get_location_data_by_location_uuid( $location_uuid );
                } else if ( count( Monoedge_Utils::monoedge_get_locations() ) > 1 ) {
                    $selected_location = ( is_array( Monoedge_Utils::monoedge_get_locations() ) && count( Monoedge_Utils::monoedge_get_locations() ) >= 1) ? Monoedge_Utils::monoedge_get_locations()[ 0 ] : "";
                }
                // $acid = ($selected_location !== null ) ? '&acid=' . $selected_location->account_id : '';
                $shop_uuid = ($selected_location !== null ) ? $selected_location["location_shop_uuids"]["Register"]["shop_uuid"] : '';
            ?>
            <div style="display:flex;justify-content:flex-end;flex-wrap:wrap;">
                <a href="" data-flow-url="<?php echo esc_attr( Monoedge_Utils::$_MONOEDGE->get_monoedge_token() . '/home/setup/step1/' ); ?>" class="monoedge-button mh50 monoedge-button-action monoedge-gap-right-10 monoedge-gap-top-8" data-id="new_tab_link" data-action="screen_change" target="_parent">
                    <span class="icon-ta"></span>
                    <?php esc_attr_e( 'Open MonoEdge Admin', 'monoedge-restaurant-system' ); ?>
                </a>
                <a href="" data-flow-url="<?php echo esc_attr( Monoedge_Utils::$_MONOEDGE->get_monoedge_token_shopapp('/location/' . $location_uuid . '/setting/reservation/businesshour/') ); ?>" class="monoedge-button mh50 monoedge-button-action monoedge-gap-right-10 monoedge-gap-top-8" data-id="new_tab_link" data-action="screen_change" target="_parent">
                    <span class="icon-ta"></span>
                    <?php esc_attr_e( 'Open Shop App', 'monoedge-restaurant-system' ); ?>
                </a>
                <a href="" data-flow-url="<?php echo esc_attr( Monoedge_Utils::$_MONOEDGE->get_monoedge_token_brand('/dashboard/location/' . $location_uuid . '/shop/'. $shop_uuid. '/product/product/') ); ?>" class="monoedge-button mh50 monoedge-button-action monoedge-gap-right-10 monoedge-gap-top-8" data-id="new_tab_link" data-action="screen_change" target="_parent">
                    <span class="icon-ta"></span>
                    <?php esc_attr_e( 'Open Back Office App', 'monoedge-restaurant-system' ); ?>
                </a>
            </div>
            <?php
            }
            ?>
        </div>
        <div class="monoedge-list flx-col">
            <?php
            global $allowed_html;
            echo wp_kses( Monoedge_Helper_Screens::generate_todo_list(), $allowed_html );
            ?>
        </div>
    </div>
    <div id="screen_alternative_flow" class="screen monoedge-section-overlay">
        <div class="monoedge-section-content monoedge-w-544 monoedge-white-back flx-col flx-align-center monoedge-spacing-v1">
            <div class="section-title"><?php esc_attr_e( 'Admin setup', 'monoedge-restaurant-system' ); ?></div>
            <div class="monoedge-overlay-text light" style="margin-top: 8px;">
                <span><?php esc_attr_e( 'You will now need to go to MonoEdge Admin in order to setup your restaurant profile. After finishing the setup you can come back and add the widgets on your website.', 'monoedge-restaurant-system' ); ?></span>
            </div>
            <div class="monoedge-column monoedge-col-h-center monoedge-col-spacing-top" style="margin-bottom: 16px;">
                <a href="" class="monoedge-button" target="_blank" rel="noreferrer"><span class="icon"></span><?php esc_attr_e( 'Start the setup', 'monoedge-restaurant-system' ); ?></a>
            </div>
        </div>
    </div>
    <?php
    $is_update = Monoedge_Utils::monoedge_get_from_wordpress_options( 'is_update', '', 'true' );
    if ( $is_update && Monoedge_Utils::$_MONOEDGE->is_authenticated() ) {
        Monoedge_Utils::monoedge_require_once( __DIR__ . '/overview_screen_options.php' );
        Monoedge_Utils::monoedge_add_to_wordpress_options( 'is_update', false );
        $screen_output = Monoedge_get_screen_sequence( 'update' );
        echo wp_kses( $screen_output['output'] , $allowed_html );
    }
    ?>
</div>

<div id="monoedge_circular_animation" style="display: none;">
    <div class="monoedge-loader-animation">
        <div class="loader btn">
            <svg class="circular-loader" viewBox="25 25 50 50">
                <circle class="loader-path" cx="50" cy="50" r="20" fill="none" stroke="#ff9432" stroke-width="2"/>
            </svg>
        </div>
    </div>
</div>