<?php
if ( !defined( 'ABSPATH' ) ) {
    exit;
} // Exit if accessed directly
?>
<?php
$screen_login = "screen-active";
$screen_forgot = '';
$screen_sign_up = '';


// Nonce velification
if (!isset($_POST['ajax_nonce']) || !wp_verify_nonce($_POST['ajax_nonce'], 'monoedge-nonce')) {
    exit('Nonce verification failed');
}
if( isset( $_POST[ 'screen_sign_up' ] ) && $_POST[ 'screen_sign_up' ] === 'true' ){
    $screen_login = '';
    $screen_sign_up = 'screen-active';
}

?>
<style type="text/css">
    #wpfooter, #wpadminbar, #adminmenumain {
        display: none;
    }

    #wpcontent, #wpfooter {
        margin-left: 0px;
        padding-left: 0px;
    }

    html.wp-toolbar {
        padding-top: 0px;
    }

    #wpbody-content {
        padding-bottom: 0px;
    }

</style>
<?php
// Login Screen

//check if empty installation_id
Monoedge_Utils::$_MONOEDGE->installation_id = get_option( 'monoedge_installation_id', '' );
if( empty( Monoedge_Utils::$_MONOEDGE->installation_id )  ){
    Monoedge_Utils::$_MONOEDGE->installation_id = wp_generate_uuid4();
    update_option( 'monoedge_installation_id', Monoedge_Utils::$_MONOEDGE->installation_id );
}
?>

<div id="screen_login" class="screen <?php  echo esc_attr( $screen_login ); ?> monoedge-section-content monoedge-w-544 monoedge-white-back flx-col flx-align-center monoedge-spacing-v1">
    <div class="section-title"><?php esc_attr_e( 'Log in to your account', 'monoedge-restaurant-system' ); ?></div>
    <?php
    monoedge_notification_section_html();
    ?>
    <form class="monoedge-form">
        <div class="monoedge-form-field">
            <div class="label"><?php esc_attr_e( 'Email', 'monoedge-restaurant-system' ); ?></div>
            <div class="field">
                <input id="email" name="email" type="text" />
            </div>
        </div>
        <div class="monoedge-form-field">
            <div class="label"><?php esc_attr_e( 'Password', 'monoedge-restaurant-system' ); ?></div>
            <div class="field">
                <input id="password" name="password" type="password" />
            </div>
        </div>

        <?php
        if ( isset( $_GET[ 'debug' ] ) && $_GET[ 'debug' ] === 'true' ) {
            ?>
            <div class="monoedge-form-field">
                <div class="label">Connection type:</div>
                <div class="field">
                    <select id="monoedge_connection_type" name="monoedge_connection_type" value="production" style="margin-top: 10px;">
                        <option value="production">Production</option>
                        <option value="staging">Staging</option>
                    </select>
                </div>
            </div>
            <?php
        }
        ?>

        <div class="monoedge-form-field flx-row form-footer">
            <div class="monoedge-filed-checkbox">
                <input id="checkbox_log" name="checkbox_log" type="checkbox">
                <label for="checkbox_log"><?php esc_attr_e( 'I’m setting up the restaurant for a client', 'monoedge-restaurant-system' ); ?></label>
            </div>
            <div class="monoedge-filed-submit">
                <?php wp_nonce_field( 'monoedge-nonce' ) ?>
                <input type="hidden" id="partner_program" name="partner_program" value="false">
                <input type="hidden" name="source" value="WORDPRESS">
                <input type="hidden" name="installation_id" value="<?php echo esc_attr( Monoedge_Utils::$_MONOEDGE->installation_id ); ?>">
                <input type="submit" data-action="monoedge_form_login" value="<?php esc_attr_e( 'Login', 'monoedge-restaurant-system' ); ?>" class="button">
            </div>
        </div>

        <div class="monoedge-form-field" style="">
            <div class="monoedge-line-spacer"></div>
            <div class="monoedge-box monoedge-space-between">
                <a href="#" class="monoedge-button-action" data-id="screen_forgot_password" data-action="screen_change" target="_parent"><?php esc_attr_e( 'Lost your password', 'monoedge-restaurant-system' ); ?></a>
                <a href="#" class="monoedge-button-action" data-id="screen_sign_up" data-action="screen_change" target="_parent"><?php esc_attr_e( 'Create a new account', 'monoedge-restaurant-system' ); ?></a>
            </div>
        </div>
    </form>
</div>
<?php
//  Forgot Password Screen
?>
<div id="screen_forgot_password" class="screen <?php echo esc_attr( $screen_forgot ); ?> monoedge-section-content monoedge-w-544 monoedge-white-back flx-col flx-align-center monoedge-spacing-v1">
    <div class="section-title"><?php esc_attr_e( 'Reset password', 'monoedge-restaurant-system' ); ?></div>
    <form class="monoedge-form">
        <div class="monoedge-form-field">
            <div class="label"><?php esc_attr_e( 'Email', 'monoedge-restaurant-system' ); ?></div>
            <div class="field">
                <input id="email" name="email" type="text" />
            </div>
        </div>


        <div class="monoedge-form-field flx-row  monoedge-align-end">
            <div class="monoedge-filed-submit">
                <?php wp_nonce_field( 'monoedge-nonce' ) ?>
                <input type="hidden" name="source" value="WORDPRESS">
                <input type="hidden" name="installation_id" value="<?php echo esc_attr( Monoedge_Utils::$_MONOEDGE->installation_id ); ?>">
                <input type="submit" data-action="monoedge_form_forgot_password" value="<?php esc_attr_e( 'Get New Password', 'monoedge-restaurant-system' ); ?>" class="button">
            </div>
        </div>

        <div class="monoedge-form-field" style="margin-top: 16px;">
            <div class="monoedge-line-spacer"></div>
            <div class="monoedge-box">
                <a href="#" class="monoedge-button-action" data-id="screen_login" data-action="screen_change" target="_parent"><?php esc_attr_e( 'Login', 'monoedge-restaurant-system' ); ?></a>
            </div>
        </div>
    </form>
</div>
<?php
//  Sign Up Screen
?>
<div id="screen_sign_up" class="screen <?php echo esc_attr( $screen_sign_up ); ?> monoedge-section-content monoedge-w-544 monoedge-white-back flx-col flx-align-center monoedge-spacing-v1">
    <div class="section-title"><?php esc_attr_e( 'Let’s start by creating a MonoEdge account', 'monoedge-restaurant-system' ); ?></div>    
    <?php
    monoedge_notification_section_html();
    ?>
    <form id="signup_form" class="monoedge-form">
        
        <div class="monoedge-column monoedge-col-h-center monoedge-col-spacing-top" style="margin-top: 10px; margin-bottom: 16px;">
            <?php
            $baseURL = '{{token}}/top/resources/price';
            $baseURL = str_replace(
                array( '{{token}}' ),
                array( Monoedge_Utils::$_MONOEDGE->get_monoedge_token() ),
                $baseURL
            );
            ?>
            <a href="<?php echo esc_url( $baseURL ); ?>" class="monoedge-button monoedge-button-action-redirect monoedge-button-signup" data-overview="<?php echo esc_url( admin_url() ) . 'admin.php?page=monoedge-overview'; ?>" target="_blank" rel="noreferrer">
                <span style="display: inline-block; font-size: 20px;"><?php esc_attr_e( 'Create account', 'monoedge-restaurant-system' ); ?></span>
                &nbsp;<br>
                <div style="display: inline-block; font-size: 16px; margin: 2px 0px 0px 0px;"><?php esc_attr_e( 'with standard plan for free', 'monoedge-restaurant-system' ); ?></div>
            </a>
        </div>

             
        <div class="monoedge-form-field" style="margin-top: 16px;">
            <div class="monoedge-box">
                <h4>
                    <?php esc_attr_e( 'By signing up you agree to our', 'monoedge-restaurant-system' ); ?>
                    <?php
                    $baseURL = '{{token}}/top/resources/tc';
                    $baseURL = str_replace(
                        array( '{{token}}' ),
                        array( Monoedge_Utils::$_MONOEDGE->get_monoedge_token() ),
                        $baseURL
                    );
                    ?>
                    <a href="<?php echo esc_url( $baseURL ); ?>?language=<?php echo esc_attr( explode( '_', get_locale() )[ 0 ] ); ?>" target="_blank"><?php esc_attr_e( 'terms', 'monoedge-restaurant-system' ); ?></a>
                    <span> & </span>
                    <?php
                    $baseURL = '{{token}}/top/resources/pp';
                    $baseURL = str_replace(
                        array( '{{token}}' ),
                        array( Monoedge_Utils::$_MONOEDGE->get_monoedge_token() ),
                        $baseURL
                    );
                    ?>
                    <a href="<?php echo esc_url( $baseURL ); ?>?language=<?php echo esc_attr( explode( '_', get_locale() )[ 0 ] ); ?>" target="_blank"><?php esc_attr_e( 'privacy policy', 'monoedge-restaurant-system' ); ?></a>
                </h4>
            </div>
            <!-- <div class="monoedge-box">
                <a href="#login_screen" class="monoedge-button-action" data-id="screen_login" data-action="screen_change" target="_parent"><?php esc_attr_e( 'Login into your existing account', 'monoedge-restaurant-system' ); ?></a>
            </div> -->
        </div>
    </form>
    
    <div class="monoedge-line-spacer">
        <div class="monoedge-line-or"><span>or</span></div>
    </div>

    <div class="section-title"><?php esc_attr_e( 'Log in to your account', 'monoedge-restaurant-system' ); ?></div>
    <?php
    monoedge_notification_section_html();
    ?>
    <form class="monoedge-form">
        <div class="monoedge-form-field">
            <div class="label"><?php esc_attr_e( 'Email', 'monoedge-restaurant-system' ); ?></div>
            <div class="field">
                <input id="email" name="email" type="text" />
            </div>
        </div>
        <div class="monoedge-form-field">
            <div class="label"><?php esc_attr_e( 'Password', 'monoedge-restaurant-system' ); ?></div>
            <div class="field">
                <input id="password" name="password" type="password" />
            </div>
        </div>
       
        <div class="monoedge-form-field flx-row form-footer">
            <div class="monoedge-filed-checkbox">
                <!-- <input id="checkbox_log" name="checkbox_log" type="checkbox">
                <label for="checkbox_log"><?php esc_attr_e( 'I’m setting up the restaurant for a client', 'monoedge-restaurant-system' ); ?></label> -->
            </div>
            <div class="monoedge-filed-submit">
                <?php wp_nonce_field( 'monoedge-nonce' ) ?>
                <input type="hidden" id="partner_program" name="partner_program" value="false">
                <input type="hidden" name="source" value="WORDPRESS">
                <input type="hidden" name="installation_id" value="<?php echo esc_attr( Monoedge_Utils::$_MONOEDGE->installation_id ); ?>">
                <input type="submit" data-action="monoedge_form_login" value="<?php esc_attr_e( 'Login', 'monoedge-restaurant-system' ); ?>" class="button">
            </div>
        </div>
        
        <div class="monoedge-form-field" style="">
            <div class="monoedge-box monoedge-space-between">
            </div>
        </div>
    </form>


</div>
    
<?php
function monoedge_notification_section_html(){
?>

<div class="monoedge-notifications disabled monoedge-section-content monoedge-w-544flx-col flx-align-center monoedge-spacing-v1">
    <div class="monoedge-form">
        <div class="monoedge-form-notification" data-type="error"><?php esc_attr_e( 'There was an error on your previous input!', 'monoedge-restaurant-system' ); ?></div>
    </div>
</div>
<?php
}
?>