<?php
// If this file is called directly, abort.
if ( !defined( 'WPINC' ) ) {
    die;
}
// Nonce velification
if (!isset($_POST['_wpnonce']) || !wp_verify_nonce($_POST['_wpnonce'], 'monoedge-nonce')) {
    exit('Nonce verification failed');
}
$css_screen_options = ( !Monoedge_Utils::$_MONOEDGE->is_authenticated() ? '' : 'screen-active' );
$monoedge_wordpress_options = Monoedge_Utils::monoedge_wp_options_data();
if(  $_POST['action'] !== 'forgot_password' ){
?>
<div id="screen_options" class="screen <?php echo esc_attr( $css_screen_options ); ?> monoedge-section monoedge-white-back flx-col" style="align-self:center; margin-top: 24px;">
    <div class="section-title"><?php esc_attr_e( 'Select what options you want to setup', 'monoedge-restaurant-system' ); ?></div>
    <div class="section-subtitle"><?php esc_attr_e( 'Choose the features that you need', 'monoedge-restaurant-system' ); ?></div>
    <div class="monoedge-list flx-col">
         <div class="monoedge-form-field list flx-row form-footer">
            <?php
            $user_id = Monoedge_Utils::monoedge_get_user()->id;
            foreach ( Monoedge_Helper_Screens::get_extra_options() as $extra_option_name =>  $extra_option ){

                if( !isset( $monoedge_wordpress_options->app_options[ $user_id ][ $extra_option_name ] ) ){
                    $preselected = ( (isset( $extra_option[ 'preselected' ] ) && $extra_option[ 'preselected' ] === 'true' ) ? 'checked' : ''  );
                }
                else{
                    $preselected = ( $monoedge_wordpress_options->app_options[ $user_id ][ $extra_option_name ] === 'true' ? 'checked' : '' );
                }
            ?>

                <div class="monoedge-filed-checkbox">
                    <input id="<?php echo esc_attr( $extra_option_name ); ?>" name="<?php echo esc_attr( $extra_option_name ); ?>" type="checkbox" <?php echo esc_attr( $preselected ); ?> >
                    <label for="<?php echo esc_attr( $extra_option_name ); ?>"><?php echo esc_attr( self::get_to_do_text_for_translation( $extra_option_name, 'label' ) ); ?></label>
                    <?php
                    if( isset( $extra_option[ 'paid' ] ) && $extra_option[ 'paid' ] === 'true' ){
                    ?>
                        <div class="monoedge-tag"><?php esc_attr_e( 'Premium', 'monoedge-restaurant-system'); ?></div>
                    <?php
                    }
                    ?>
                </div>
            <?php
            }
            ?>
            <div class="monoedge-filed-submit">
                <div class="monoedge-button monoedge-button-action" data-id="screen_alternative_flow" data-action="monoedge_chosen_options"><?php esc_attr_e( 'Continue', 'monoedge-restaurant-system' ); ?></div>
            </div>
        </div>
    </div>
</div>
<?php
}
?>

<?php
$css_screen_usage = ( $_POST[ 'action' ] === 'forgot_password' ? 'screen-active' : '');
?>
<div id="screen_forgot_password_done" class="screen <?php echo esc_attr( $css_screen_usage ); ?> monoedge-section-content monoedge-w-544 monoedge-white-back flx-col flx-align-center monoedge-spacing-v1">
        <div class="section-title"><?php esc_attr_e( 'Reset password', 'monoedge-restaurant-system' ); ?></div>
        <div class="monoedge-form">
            <div class="monoedge-form-notification" data-type="success"><?php esc_attr_e( 'You will receive an email message with instructions on how to reset your password.', 'monoedge-restaurant-system' ); ?></div>
            <div class="monoedge-form-field" style="margin-top: 16px;">
                <div class="monoedge-line-spacer"></div>
                <div class="monoedge-box">
                    <a href="#" class="monoedge-button-action" data-id="screen_login" data-action="screen_change" target="_parent"><?php esc_attr_e( 'Login', 'monoedge-restaurant-system' ); ?></a>
                </div>
            </div>
        </div>
    </div>
<?php
$user_id = Monoedge_Utils::monoedge_get_user()->id;
$css_screen_usage = ( (empty( $monoedge_wordpress_options->app_options[ $user_id ][ 'share_usage_data' ] ) && $_POST[ 'action' ] !== 'forgot_password' ) ? 'screen-active' : '');
?>
<div id="screen_data_usage" class="screen <?php echo esc_attr( $css_screen_usage ); ?> monoedge-section-overlay">
    <div class="monoedge-section-content monoedge-w-544 monoedge-white-back flx-col flx-align-center monoedge-spacing-v1">
        <div class="section-title"><?php esc_attr_e( 'Help us improve MonoEdge', 'monoedge-restaurant-system' ); ?></div>
        <div class="monoedge-line-spacer"></div>
        <div class="monoedge-overlay-text">
            <span><?php esc_attr_e( 'Become a super contributor by opting in to share non-sensitive plugin data.', 'monoedge-restaurant-system' ); ?><a href="https://langing.as3.monoedge.ai/top/resources/pp" target="_blank" rel="noreferrer"><?php esc_attr_e( 'Learn more', 'monoedge-restaurant-system' ); ?></a></span>
        </div>
        <div class="monoedge-column monoedge-col-h-right monoedge-col-spacing-top">
            <a href="" class="monoedge-link monoedge-button-action" data-id="screen_options" data-value="no" data-action="monoedge_set_option" data-option="share_usage_data"><?php esc_attr_e( 'Don’t share', 'monoedge-restaurant-system' ); ?></a>
            <a href="" class="monoedge-button monoedge-button-action" data-id="screen_options" data-value="yes" data-action="monoedge_set_option" data-option="share_usage_data"><?php esc_attr_e( 'Share usage data', 'monoedge-restaurant-system' ); ?></a>
        </div>
    </div>
</div>

<?php
$css_screen_usage = '';
?>
<div id="screen_alternative_flow" class="screen monoedge-section-overlay">
    <div class="monoedge-section-content monoedge-w-544 monoedge-white-back flx-col flx-align-center monoedge-spacing-v1">
        <div class="section-title"><?php esc_attr_e( 'Admin setup', 'monoedge-restaurant-system' ); ?></div>
        <div class="monoedge-overlay-text light" style="margin-top: 8px;">
            <span><?php esc_attr_e( 'You will now need to go to MonoEdge Admin in order to setup your restaurant profile. After finishing the setup you can come back and add the widgets on your website.', 'monoedge-restaurant-system' ); ?></span>
        </div>
        <div class="monoedge-column monoedge-col-h-center monoedge-col-spacing-top" style="margin-bottom: 16px;">
            <a href="<?php echo esc_url( Monoedge_Utils::$_MONOEDGE->get_monoedge_token() ) . '/home/setup/step1/'; ?>" class="monoedge-button" target="_blank" rel="noreferrer"><span class="icon"></span><?php esc_attr_e( 'Start the setup', 'monoedge-restaurant-system' ); ?></a>
        </div>
    </div>
</div>

<div id="screen_goto_overview" class="screen monoedge-section-overlay">
    <div class="monoedge-section-content monoedge-w-544 monoedge-white-back flx-col flx-align-center monoedge-spacing-v1">
        <div class="section-title"><?php esc_attr_e( 'Your restaurant profile is already setup', 'monoedge-restaurant-system' ); ?></div>
        <div class="monoedge-overlay-text light" style="margin-top: 8px;">
            <span><?php esc_attr_e( 'You can now continue to setup the rest of the account', 'monoedge-restaurant-system' ); ?></span>
        </div>
        <div class="monoedge-column monoedge-col-h-center monoedge-col-spacing-top" style="margin-bottom: 16px;">
            <a href="<?php echo esc_url( Monoedge_Utils::$_MONOEDGE->get_monoedge_token() ) . '&r=app.admin.setup'; ?>" class="monoedge-button" target="_blank" rel="noreferrer"><span class="icon"></span><?php esc_attr_e( 'Continue setting up online ordering', 'monoedge-restaurant-system' ); ?></a>
        </div>
    </div>
</div>