<?php
if ( !defined( 'ABSPATH' ) ) {
    exit;
} // Exit if accessed directly

if ( !Monoedge_Utils::$_MONOEDGE->is_authenticated() ) {
    require(MONOEDGE_PLUGIN_DIR . 'includes/admin/overview/overview.php');
    die();
}
$custom_css_location = Monoedge_Utils::monoedge_get_from_wordpress_options( 'default_location', '' );

if ( isset( $_POST[ 'css' ] ) ) {
    if ( !(current_user_can( 'manage_options' ) && isset( $_POST[ '_wpnonce' ] ) && wp_verify_nonce( $_POST[ '_wpnonce' ], 'monoedge-mor-customize-css' )) ) {
        die( 'Access restricted, security check failed!' );
    }

    $custom_css = json_decode( stripslashes( sanitize_text_field( $_POST[ 'css' ] ) ), true );
    $custom_css_location = stripslashes( sanitize_text_field( $_POST[ 'location' ] ) );

    $temp_custom_css = Monoedge_Utils::monoedge_get_locations_custom_css( $custom_css_location );
    $temp_custom_css[ $custom_css[ 'type' ] ] = $custom_css;
    Monoedge_Utils::monoedge_set_locations_custom_css( $temp_custom_css, $custom_css_location );
    /*Monoedge_Utils::$_MONOEDGE->custom_css[$custom_css['type']] = $custom_css;
    Monoedge_Utils::$_MONOEDGE->save_user_data(array('custom_css' => Monoedge_Utils::$_MONOEDGE->custom_css));*/

    $monoedge_wordpress_options = Monoedge_Utils::monoedge_wp_options_data();
    $per_user_app_options = $monoedge_wordpress_options->{'app_options'}[ Monoedge_Utils::$_MONOEDGE->user->id ];
    $per_user_app_options[ 'default_location' ] = $custom_css_location;
    $monoedge_wordpress_options->{'app_options'}[ Monoedge_Utils::$_MONOEDGE->user->id ] = $per_user_app_options;
    Monoedge_Utils::monoedge_database_option_operation( 'update', 'monoedge_wordpress_options', $monoedge_wordpress_options );
}
?>
<div id="monoedge-consent" data-consent="<?php echo esc_attr( Monoedge_Utils::monoedge_get_from_wordpress_options( 'share_usage_data', '' ) ) ?>"></div>
<div class="monoedge-settings-tabs">
    <div class="settings-tab active" data-id="settings-account"><?php esc_attr_e( 'Account', 'monoedge-restaurant-system' ); ?></div>
</div>

<!-- <div class="settings-account monoedge-settings-content"> -->
<div class="settings-account monoedge-settings-content active">
    <div class="monoedge-wrapper">
        <div class="monoedge-section monoedge-spacing-v1 flx-col">
            <div class="section-title big"><?php esc_attr_e( 'You are already logged in', 'monoedge-restaurant-system' ); ?></div>
            <div class="monoedge-section-content monoedge-white-back flx-col flx-align-left">
                <div class="monoedge-form" style="padding:0px;">
                    <div class="monoedge-form-notification info" data-type="success"><?php esc_attr_e( 'If you disconnect your account, the “Reservation” and “Mobile Order” buttons already published on your page will remain in place. You will also no longer be able to change any information from the WordPress interface. You will need to log in again to make changes.', 'monoedge-restaurant-system' ); ?></div>
                </div>
            </div>
            <div class="monoedge-section-content monoedge-w-544 monoedge-white-back flx-col flx-align-left monoedge-spacing-v1">
                <form class="monoedge-form account">
                    <div class="monoedge-form-field">
                        <div class="label"><?php esc_attr_e( 'Email', 'monoedge-restaurant-system' ); ?></div>
                        <div class="field">
                            <input id="user_email" name="user_email" type="text" value="<?php echo esc_attr( Monoedge_Utils::monoedge_get_user()['email'] ); ?>" readonly/>
                        </div>
                    </div>
                    <div class="monoedge-form-field">
                        <div class="label"><?php esc_attr_e( 'Installation ID', 'monoedge-restaurant-system' ); ?></div>
                        <div class="field">
                            <input id="user_install_id" name="user_install_id" type="text" value="<?php echo esc_attr( Monoedge_Utils::$_MONOEDGE->installation_id ); ?>" readonly/>
                        </div>
                    </div>


                    <div class="monoedge-form-field flx-row form-footer ">
                        <div class="monoedge-filed-submit" style="margin-left: auto;">
                            <?php wp_nonce_field( 'monoedge-nonce' ) ?>
                            <input type="submit" data-action="monoedge_form_disconnect" data-id="admin.php?page=monoedge-overview" value="<?php esc_attr_e( 'Disconnect', 'monoedge-restaurant-system' ); ?>" class="button v2">
                        </div>
                    </div>
                </form>
            </div>
            <div class="monoedge-section-content account monoedge-w-544 monoedge-white-back flx-col flx-align-left monoedge-spacing-v1">
                <div class="section-title"><?php esc_attr_e( 'Help us improve MonoEdge', 'monoedge-restaurant-system' ); ?></div>
                <div class="monoedge-overlay-text monoedge-gap-top-8 monoedge-gap-bottom-24">
                    <span><?php esc_attr_e( 'Become a super contributor by opting in to share non-sensitive plugin data and to receive periodic email updates from us.', 'monoedge-restaurant-system' ); ?><a href="https://landing.as3.monoedge.ai/top/resources/pp" target="_blank" rel="noreferrer"><?php esc_attr_e( 'Learn more', 'monoedge-restaurant-system' ); ?></a></span>
                </div>
                <div class="monoedge-switch-control">
                    <?php
                    $share_checked = (Monoedge_Utils::monoedge_get_from_wordpress_options( 'share_usage_data', '' ) === 'yes' ? 'checked' : '' );
                    ?>
                    <label for="share_usage_data" class=" monoedge-button-action" data-option="share_usage_data" data-action="monoedge_switch_set">
                        <input id="share_usage_data" name="share_usage_data" type="checkbox" autocomplete="off" <?php echo esc_attr( $share_checked ); ?>>
                        <div class="switch-control">
                            <div class="switch-graphic"></div>
                        </div>
                    </label>
                    <div class="switch-label"><?php esc_attr_e( 'Share usage data', 'monoedge-restaurant-system' ); ?></div>
                </div>
            </div>
        </div>
    </div>
</div>


<form method="post" id="monoedge-customize-button">
    <?php wp_nonce_field( 'monoedge-mor-customize-css' ) ?>
    <input name="location" id="monoedge-button-custom-css-location" type="hidden">
    <input name="css" id="monoedge-button-custom-css" type="hidden">
</form>


    <script>
        var clipboard1 = new Clipboard( '.copy-ordering-button' );
        var clipboard2 = new Clipboard( '.copy-reservations-button' );
        var clipboard3 = new Clipboard( '.copy-full-menu-button' );

        clipboard1.on( 'success', function ( e ) {
            alert( 'Code copied!' )
        } );

        clipboard1.on( 'error', function ( e ) {
            alert( 'Error! Please manually copy the code.' )
        } );

        clipboard2.on( 'success', function ( e ) {
            alert( 'Code copied!' )
        } );

        clipboard2.on( 'error', function ( e ) {
            alert( 'Error! Please manually copy the code.' )
        } );

        clipboard3.on( 'success', function ( e ) {
            alert( 'Code copied!' )
        } );

        clipboard3.on( 'error', function ( e ) {
            alert( 'Error! Please manually copy the code.' )
        } );


        jQuery( document ).find( '.monoedge-button' ).css( 'pointer-events', 'none' );

        document.addEventListener( "DOMContentLoaded", function ( event ) {
            if( document.readyState === 'interactive' ) {
                monoedgeDisplayShortcode();
            }
        } );
    </script>

