<?php
/*
  Plugin Name: MonoEdge Restaurant System
  Plugin URI: https://landing.as3.monoedge.ai/top/resources/wordpress-restaurant-plugin
  Description: This plugin adds value to the entire process from the reservation to in-shop customer service to ensure the best possible customer experience. Get restaurant menus, mobile ordering, restaurant reservation system and POS with a simple and friendly interface. Standard plan for free, no hidden costs, no setup fees - unlimited restaurant reservations and mobile orders.

  Version: 1.0.1
  Requires at least: 5.2
  Requires PHP:      7.2
  Author: MONOEDGE
  Author URI: https://landing.as3.monoedge.ai/
  License: GPL-3.0-or-later
  License URI: http://www.gnu.org/licenses/gpl-3.0.html
  Text Domain: monoedge-restaurant-system
  Domain Path: /languages

  @package  RestaurantSystem
  @category Core
  @author   MONOEDGE
  @copyright 2024 MONOEDGE
*/


if ( ! defined( 'ABSPATH' ) ) {
	exit;
} // Exit if accessed directly

if ( ! defined( 'MONOEDGE_PHP_COMPARE' ) ) {
	define( 'MONOEDGE_PHP_COMPARE', version_compare( PHP_VERSION, '5.3', '<' ) );
	// echo "MONOEDGE_PHP_COMPARE: " . MONOEDGE_PHP_COMPARE . "<br>";
}

if ( ! defined( 'MONOEDGE_PLUGIN_DIR' ) ) {
	define( 'MONOEDGE_PLUGIN_DIR', trailingslashit( ( MONOEDGE_PHP_COMPARE ? dirname( __FILE__ ) : __DIR__ ) ) );
	// echo "MONOEDGE_PLUGIN_DIR: " . MONOEDGE_PLUGIN_DIR . "<br>";
}

if ( ! defined( 'MONOEDGE_PLUGIN_URL' ) ) {
	define( 'MONOEDGE_PLUGIN_URL', plugin_dir_url( __FILE__ ) );
}

if ( ! defined( 'WP_ENVIRONMENT_TYPE' ) ) {
    define( 'WP_ENVIRONMENT_TYPE', 'production' );
}

if ( ! defined( 'MONOEDGE_BASE_URL' ) ) {
    define( 'MONOEDGE_BASE_URL', 'https://landing.as3.monoedge.ai' );
}
if ( ! defined( 'MONOEDGE_API_URL' ) ) {
    define( 'MONOEDGE_API_URL', MONOEDGE_BASE_URL . '/receiver' );
}


global $allowed_html;
$allowed_html = array(
    'a' => array(
        'id' => array(),
        'href' => array(),
        'class' => array(),
        'data-id' => array(),
        'data-id_url' => array(),
        'data-action' => array(),
        'data-option' => array(),
        'data-value' => array(),
        'data-flow-url' => array(),
        'data-flow_url' => array(),
        'data-title' => array(),
        'data-completed' => array(),
        'data-screen' => array(),
        'data-location' => array(),
        'data-uid' => array(),
        'data-type' => array(),
        'data-redirect' => array(),
        'data-overview' => array(),
        'data-consent' => array(),
        'data-value' => array(),
        'data-target' => array(),
        'data-tracking' => array(),
        'data-monoedge-cuid' => array(),
        'data-monoedge-ruid' => array(),  
        'style' => array(),
        'target' => array(),
        'value' => array()
    ),
    'span' => array(
        'id' => array(),
        'href' => array(),
        'class' => array(),
        'data-id' => array(),
        'data-id_url' => array(),
        'data-action' => array(),
        'data-option' => array(),
        'data-value' => array(),
        'data-flow-url' => array(),
        'data-flow_url' => array(),
        'data-title' => array(),
        'data-completed' => array(),
        'data-screen' => array(),
        'data-location' => array(),
        'data-uid' => array(),
        'data-type' => array(),
        'data-redirect' => array(),
        'data-overview' => array(),
        'data-consent' => array(),
        'data-value' => array(),
        'data-target' => array(),
        'data-tracking' => array(),
        'data-monoedge-cuid' => array(),
        'data-monoedge-ruid' => array(),   
        'style' => array(),     
        'target' => array(),
        'value' => array()
    ),
    'div' => array(
        'id' => array(),
        'href' => array(),
        'class' => array(),
        'data-id' => array(),
        'data-id_url' => array(),
        'data-action' => array(),
        'data-option' => array(),
        'data-value' => array(),
        'data-flow-url' => array(),
        'data-flow_url' => array(),
        'data-title' => array(),
        'data-completed' => array(),
        'data-screen' => array(),
        'data-location' => array(),
        'data-uid' => array(),
        'data-type' => array(),
        'data-redirect' => array(),
        'data-overview' => array(),
        'data-consent' => array(),
        'data-value' => array(),
        'data-target' => array(),
        'data-tracking' => array(),
        'data-monoedge-cuid' => array(),
        'data-monoedge-ruid' => array(),  
        'style' => array(),      
        'target' => array(),
        'value' => array()
    ),
    'input' => array(
        'id' => array(),
        'name' => array(),
        'type' => array(),
        'checked' => array(),
        'href' => array(),
        'class' => array(),
        'data-id' => array(),
        'data-id_url' => array(),
        'data-action' => array(),
        'data-option' => array(),
        'data-value' => array(),
        'data-flow-url' => array(),
        'data-flow_url' => array(),
        'data-title' => array(),
        'data-completed' => array(),
        'data-screen' => array(),
        'data-location' => array(),
        'data-uid' => array(),
        'data-type' => array(),
        'data-redirect' => array(),
        'data-overview' => array(),
        'data-consent' => array(),
        'data-value' => array(),
        'data-target' => array(),
        'data-tracking' => array(),
        'data-monoedge-cuid' => array(),
        'data-monoedge-ruid' => array(),  
        'style' => array(),      
        'target' => array(),
        'value' => array()
    ),
    'label' => array(
        'for' => array(),
        'style' => array(),
    )
);


class MONOEDGE_Restaurant_System {
	var $version = '1.0.1',
		$api_token = null,
        $email = null,
		$user = null,
        $admin_language = null,
		$installation_id = null,
        $error = null;

	private static $_instance = null;

	// Constructor
	private function __construct() {
		if ( ! class_exists( 'Monoedge_Utils' ) ) {
			require_once MONOEDGE_PLUGIN_DIR . '/includes/utils/class-monoedge-utils.php';
		}
		$this->monoedge_system_config();
		if ( wp_doing_ajax() ) {
			$this->monoedge_system_ajax();
		} else {
			if ( is_admin() ) {
				$this->monoedge_system_admin();
			} else {
				$this->monoedge_system_frontend();
			}
		}
		$this->monoedge_system_init();
	}

    public function monoedge_system_config() {
        $this->admin_language = strtolower( str_replace( '_', '-', get_user_locale() ) );
		$this->load_user_data();
        $token_available = $this->check_if_token_available();
        Monoedge_Utils::monoedge_require_once( MONOEDGE_PLUGIN_DIR . '/includes/admin/class-monoedge-admin-screens.php' );
        Monoedge_Utils::monoedge_require_once( MONOEDGE_PLUGIN_DIR . 'includes/modules/class-monoedge-modules.php' );
    }

    public function monoedge_system_ajax() {
		// add_action( 'wp_ajax_restaurant_system_customize_button', array( $this, 'customize_button_dialog' ) );
        // add_action( 'wp_ajax_monoedge_set_default_location', array( $this, 'monoedge_set_default_location' ) );
    }

	// store the admin dropdown location selected.
	// Value to be used to pre-select the location in publishing
	// public function monoedge_set_default_location() {
	// 	$location = isset( $_POST[ 'location' ] ) ? (string) $_POST[ 'location' ] : '';

    //     $action = isset( $_GET[ 'action' ] ) ? $_GET[ 'action' ] : '';
    //     $response = array( 'action' => $action );
    //     if ( Monoedge_Utils::monoedge_capabilities_check() ) {
    //         Monoedge_Utils::monoedge_capabilities_check_failed( $response );
    //     }
    //     $monoedge_wordpress_options->{'app_options'}[ Monoedge_Utils::$_MONOEDGE->user['user']['id'] ]['default_location'] = $location;
	// 	Monoedge_Utils::monoedge_database_option_operation( 'update', 'monoedge_wordpress_options', $monoedge_wordpress_options );
	// 	echo json_encode( array( 'message' => 'done', 'post' => $_POST ) );
	// 	exit;
	// }

    public function monoedge_system_admin() {
        add_action( 'media_buttons', array( $this, 'monoedge_add_ordering_media_button' ) );
        add_action( 'admin_enqueue_scripts', array( $this, 'add_media_scripts' ) );
        add_action( 'admin_enqueue_scripts', array( $this, 'monoedge_set_default_location' ) );
        // add_action( 'wp_loaded', array( $this, 'monoedge_template_redirect_old_link' ) );
    }
    
	public function monoedge_set_default_location(  $input_location_uuid = null) {
        if ( Monoedge_Utils::$_MONOEDGE->is_authenticated() ) {
            $monoedge_wordpress_options = Monoedge_Utils::monoedge_wp_options_data();
            $_flag_find_cur_location = false;
            if ( $input_location_uuid !== null  ) {
                if ( isset($monoedge_wordpress_options->{'app_options'})) {
                    if (isset($monoedge_wordpress_options->{'app_options'}[ $this->user['user']['id'] ])) {
                        if (isset($monoedge_wordpress_options->{'app_options'}[ $this->user['user']['id'] ]['default_location'] )) {
                            if( str_starts_with( $monoedge_wordpress_options->{'app_options'}[ $this->user['user']['id'] ]['default_location'], 'location_' ) ){
                                $_flag_find_cur_location = true;
                            }
                        }
                    }
                } 
                if ( $_flag_find_cur_location == false ) {
                    $_default_location_uuid = "";
                    if ( count($this->user['user']['locations']) > 0 ) {
                        $_default_location_uuid = $this->user['user']['locations'][0]['location_uuid'];
                    }
                    $monoedge_wordpress_options->{'app_options'}[ $this->user['user']['id'] ]['default_location'] = $_default_location_uuid;
                    Monoedge_Utils::monoedge_database_option_operation( 'update', 'monoedge_wordpress_options', $monoedge_wordpress_options );
                }
            } else {
                $monoedge_wordpress_options->{'app_options'}[ $this->user['user']['id'] ]['default_location'] = $input_location_uuid;
                Monoedge_Utils::monoedge_database_option_operation( 'update', 'monoedge_wordpress_options', $monoedge_wordpress_options );
            }
        }
    }


    //     public function monoedge_template_redirect_old_link( $template ) {
    //         $old_pages = array( 'monoedge-admin', 'monoedge-publishing', 'monoedge-extras', 'monoedge-partner', 'monoedge-options' );
    //         if( isset( $_GET, $_GET[ 'page' ] ) && in_array( $_GET[ 'page' ], $old_pages, true ) ){
    //             wp_safe_redirect( admin_url( 'admin.php?page=monoedge-overview' ) );
    //             exit;
    //         }
    //     }

    public function monoedge_system_frontend() {
        add_action( 'wp_print_styles', array( $this, 'add_public_media_scripts' ) );
    }

    public function monoedge_system_init() {
        register_activation_hook( __FILE__, array( 'MONOEDGE_Restaurant_System', 'monoedge_install' ) );
        register_uninstall_hook( __FILE__, array( 'MONOEDGE_Restaurant_System', 'monoedge_uninstall' ) );

        // if( get_option( 'monoedge_check_old_widgets_elementor' ) !== 'no' ){
        add_action( 'wp', array( $this, 'monoedge_cron_job_register' ) );
        add_action( 'monoedge_cron_check_elementor', array( 'MONOEDGE_Restaurant_System', 'check_for_elementor_old_widgets_in_posts' ) );
        // }

        add_action( 'wp_enqueue_scripts', array( $this,  'monoedge_set_script_translations' ), 100 );
        add_action( 'init', array( $this, 'monoedge_load_languages' ) );
        add_action( 'admin_init', array( $this, 'monoedge_plugin_activation_redirect' ) );
        add_action( 'wpmu_new_blog', array( $this, 'monoedge_new_blog' ), 10, 6 );

        //update process complete
        add_action( 'upgrader_process_complete', array( $this, 'monoedge_upgrader_process_complete'), 10, 2 );
        add_action( 'plugins_loaded', array( $this, 'monoedge_plugins_loaded' ) );
    }

    public function monoedge_cron_job_register(){
        if ( !wp_next_scheduled( 'monoedge_cron_check_elementor' ) ) {
            $event_recurrence = 'daily'; // daily
            wp_schedule_event( time(), $event_recurrence, 'monoedge_cron_check_elementor' );
        }
    }

    public function monoedge_upgrader_process_complete( $upgrader_options, $options ) {
        if ( $options['action'] === 'update' && $options['type'] === 'plugin' && is_array( $options['plugins']) && !empty( $options['plugins'])) {
            $monoedge_plugin = plugin_basename( __FILE__ );
            foreach ( $options[ 'plugins' ] as $plugin ) {
                // check if the plugin is in the update plugins list
                if ( $plugin == $monoedge_plugin ) {
                    // store old version so we can compare it when the
                    // new version is loaded for the first time
                    update_option( 'monoedge_plugin_version', Monoedge_Utils::$_MONOEDGE->version );
                }
            }
            unset( $plugin );
        }
    }

    public function monoedge_plugins_loaded() {
        // get the previous version that was stored when the action/hook 'upgrader_process_complete' was called
        $monoedge_plugin_updated_version = get_option( 'monoedge_plugin_version', '0' );

        // Run code that should match a certain version number.
        /*
        *  This part should be maintained, periodically, when we reach
        *  a certain percentage of installations with a desired version number
        *
        */

        // update code for versions lower than 2.0.2
        // if ( Monoedge_Utils::$_MONOEDGE->version === '2.0.2' && version_compare( $monoedge_plugin_updated_version, '2.0.2', '<' ) && current_user_can('manage_options')) {
        //     update_option( 'monoedge_plugin_version', Monoedge_Utils::$_MONOEDGE->version );
        //     Monoedge_Utils::monoedge_set_default_app_options();
        //     Monoedge_Utils::monoedge_custom_css_check_and_set_defaults( Monoedge_Utils::$_MONOEDGE->custom_css );
        //     Monoedge_Helper_Screens::set_default_setup_options();
        //     Monoedge_Utils::monoedge_add_to_wordpress_options( 'is_update', true );
        // } else if( Monoedge_Utils::$_MONOEDGE->version === '2.1.0' && version_compare( $monoedge_plugin_updated_version, '2.1.0', '<' ) && current_user_can( 'manage_options' ) ){
        //     update_option( 'monoedge_plugin_version', Monoedge_Utils::$_MONOEDGE->version );
        //     self::check_for_elementor_old_widgets_in_posts();
        // }

    }

    // public function monoedge_delete_post_check_old_widget_elementor( $pid ){
    //     self::check_for_elementor_old_widgets_in_posts();
    // }

    public function monoedge_plugin_activation_redirect() {
        if( get_option( 'monoedge_check_old_widgets_elementor' ) !== 'no' ){
            add_action( 'delete_post', array( $this, 'monoedge_delete_post_check_old_widget_elementor' ), 10 );
        }

        if ( !wp_doing_ajax() &&
            (int)get_option( 'monoedge_plugin_redirect', false ) === wp_get_current_user()->ID && !is_super_admin( wp_get_current_user()->ID ) ) {
            // Delete the option so we don't redirect more than once
            delete_option( 'monoedge_plugin_redirect' );
            $_POST['redirect'] = 'monoedge_load_screen';
            wp_safe_redirect( admin_url( 'admin.php?page=monoedge-overview&redirect=monoedge_load_screen' ) );
            //wp_safe_redirect( admin_url( 'admin.php?page=monoedge-screens' ) );
            exit;
        }
    }
    public function generate_installation_id() {
        return wp_generate_uuid4();
    }

    public function monoedge_fullscreen_mode() {
        echo '<style type="text/css">
        #adminmenumain, #wpadminbar{
            display: none;
        }

        #wpcontent, #wpfooter {
            margin-left: 0px;
        }

        #wpcontent {
            padding-left: 0px;

        }
        html.wp-toolbar{
            padding-top: 0px;
        }';
    }


    public function monoedge_add_ordering_media_button() {
        ?>
        <a id="monoedge-ordering" class="button thickbox" onclick="monoedge_showThickBox('restaurant_system_insert_dialog')">
            <img src="<?php echo esc_attr( plugins_url( 'assets/images/MONOEDGE-icon-black.svg', __FILE__ ) ); ?>"> Reservations - Mobile Ordering - POS
        </a>
        <?php
    }


    public function customize_button_dialog() {
        // Nonce velification
        if (!isset($_GET['_wpnonce']) || !wp_verify_nonce($_GET['_wpnonce'], 'monoedge-nonce')) {
            exit('Nonce verification failed');
        }
        $action = isset( $_GET[ 'action' ] ) ? $_GET[ 'action' ] : '';
        $response = array( 'action' => $action );

        if ( Monoedge_Utils::monoedge_capabilities_get_check() ) {
            Monoedge_Utils::monoedge_capabilities_check_failed( $response );
        }

        Monoedge_Utils::monoedge_include( MONOEDGE_PLUGIN_DIR . 'includes/admin/settings/customize-button.php' );
    }


    public function monoedge_check_if_error_and_display_it( $response, $forceLogout = false ) {
        if ( is_wp_error( $response ) ) {
            if (isset($forceLogout) && $response->get_error_message() == 'Login token not found') {
                Monoedge_Utils::$_MONOEDGE->remove_user_data();
                echo "<script type='text/javascript'>
                            window.location=document.location.href;
                        </script>";
                exit;
            }
            $this->error = $response->get_error_message();
            require(MONOEDGE_PLUGIN_DIR . 'includes/admin/overview/overview.php');
            die;
        } else if ( isset($response['body']) ) {
            $data = json_decode($response['body'],true);
            if ( isset($data['detail']) ) {
                if ( $data['detail']=="Signature has expired.") {
                    Monoedge_Utils::$_MONOEDGE->remove_user_data();
                    echo "<script type='text/javascript'>
                                window.location=document.location.href;
                            </script>";
                    exit;
                }
            }            
        } else {
            $this->error = null;
        }
    }

    public function check_if_token_available() {
        if ( ! $this->api_token ) {
            return false;
        }
        $response = wp_remote_post( MONOEDGE_API_URL . '/check-token/', array(
                'method'  => 'POST',
                'headers' => array(
                    'Authorization' => 'JWT ' . $this->api_token,
                    'content-type'  => 'application/json'
                ),
                'body'    => wp_json_encode( array( 'wordpress' => True ) )
            )
        );
        $respone_body = json_decode( $response[ 'body' ] , true);
        if ( isset( $respone_body->check ) && $respone_body->check == true) {
            return true;
        }
        return false;
    }

    // public function get_monoedge_token() {
    //     Monoedge_Utils::write_log("$this->user");
    //     Monoedge_Utils::write_log($this->user);
    //     $response = wp_remote_post( MONOEDGE_API_URL . 'api-token-auth/', array(
    //             'method'  => 'POST',
    //             'headers' => array(
    //                 'content-type'  => 'application/json'
    //             ),
    //             'body'    =>  json_encode( array(
    //                 'username' => $this->user->email,
    //                 'password' => $this->user->password,
    //             ))
    //         )
    //     );
    //     $respone_body = json_decode( $response[ 'body' ] );
    //     if ( isset( $respone_body->error ) ) {
    //         $errors = new WP_Error();
    //         $errors->add( '1', $respone_body->error );
    //         $this->monoedge_check_if_error_and_display_it( $errors );
    //     }
    // }

	public function get_monoedge_token( $target = 'admin' ) {
		$url = MONOEDGE_BASE_URL;
		return $url;
	}
	public function get_monoedge_token_shopapp( $adding = '') {
        $_user = Monoedge_Utils::monoedge_get_user();
        $url = "https://shopapp." . $_user["server"]["domain"] .  $adding;
		return $url;
	}
	public function get_monoedge_token_brand( $adding = '' ) {
        $_user = Monoedge_Utils::monoedge_get_user();
        $url = "https://brand." . $_user["server"]["domain"] . $adding;
		return $url;
	}

    /**
     * MonoEdge API call
     *
     * @param string $route API route
     * @param string $method wp_remote_post method type: GET or POST
     * @param string $body value that will be encoded to JSON
     *
     */
    public function monoedge_api_call( $route, $method = 'POST', $body = array() ) {
		// if ( ! $this->is_authenticated() ) {
		// 	return null;
		// }
		if ( ! $this->is_authenticated() ) {            
            Monoedge_Utils::$_MONOEDGE->remove_user_data();
            echo "<script type='text/javascript'>
                        window.location=document.location.href;
                    </script>";
            exit;
            require(MONOEDGE_PLUGIN_DIR . 'includes/admin/overview/overview.php');
            die;
            return null;
		}
        // if ( ! $this->auth_token ) {
        //     $auth_token = $this->get_monoedge_token();
        //     $this->monoedge_check_if_error_and_display_it( $auth_token );
        //     $this->auth_token = $auth_token;
        // }
        $tmp_api_token = Monoedge_Utils::monoedge_get_all_data()['api_token'];
        $response = wp_remote_post( MONOEDGE_API_URL . $route, array(
                'method'  => $method,
                'headers' => array(
                    'Authorization' => 'JWT ' . $tmp_api_token,
                    'content-type'  => 'application/json'
                ),
                'body'    => wp_json_encode( $body ),
            )
        );

        $this->monoedge_check_if_error_and_display_it( $response );

        $respone_body = json_decode( $response[ 'body' ], true );
        if ( isset( $respone_body->error ) ) {
            $errors = new WP_Error();
            $errors->add( '1', $respone_body->error );
            $this->monoedge_check_if_error_and_display_it( $errors );
        }

        return $respone_body;
    }
    
    public function get_and_update_user_data() {
		if ( ! $this->is_authenticated() ) {
            return null;
        }
        $user_data = $this->monoedge_api_call( '/get-user-database/' );
        $this->save_user_data( $user_data );
        Monoedge_Utils::monoedge_get_all_data();
    }


	public function save_user_data( $options ) {
		$user_data_obj = Monoedge_Utils::monoedge_get_all_data();
		if ( ! $user_data_obj ) {
			$user_data_obj = array();
		}
		foreach ( $options as $key => $value ) {
			$user_data_obj[$key] = $value;
		}
		update_option( 'monoedge_user_data', $user_data_obj );
        $this->load_user_data();
	}


    // public function update_user_data( $options ) {
    //     $user =  $this->monoedge_api_call( 'user/restaurants' );

    //     if ( ! $location_data_obj ) {
    //         $location_data_obj = new stdClass();
    //     }

    //     foreach ( $options as $key => $value ) {
    //         $location_data_obj->$key = $value;
    //     }

    //     update_option( 'monoedge_user_data', $location_data_obj );
    // }

    /**
     * Styling & JS: loading stylesheets and js for the plugin.
     */
    public function add_media_scripts( $page ) {

        wp_enqueue_script( 'restaurant_system_media_btn_js', plugins_url( 'assets/js/wp-editor-monoedge-media-button.js', __FILE__ ), array(), $this->version, true );
        wp_enqueue_script( 'restaurant_system_clipboard_js', plugins_url( 'assets/js/clipboard.min.js', __FILE__ ), array(), '1.7.1', true );

        wp_enqueue_script( 'restaurant_system_customize_btn_js', plugins_url( 'assets/js/admin-customize-button.js', __FILE__ ), array(), $this->version, true );
        wp_localize_script( 'restaurant_system_customize_btn_js', 'monoedge_ajax_url', array( 'ajax_url' => admin_url( 'admin-ajax.php' ) , 'ajax_nonce' => wp_create_nonce('monoedge-nonce') ) );

        wp_enqueue_script( 'restaurant_monoedge_main_js', plugins_url( 'includes/admin/assets/js/main.js', __FILE__ ), array(), $this->version, true );
        wp_localize_script( 'restaurant_monoedge_main_js', 'monoedge_ajax_url', array( 'ajax_url' => admin_url( 'admin-ajax.php' ) , 'ajax_nonce' => wp_create_nonce('monoedge-nonce') ) );
        wp_enqueue_script( 'restaurant_system_public_scripts_js', plugins_url( 'assets/js/public-scripts.js', __FILE__ ), array(), $this->version, true );

        wp_enqueue_style( 'restaurant_system_style', plugins_url( 'assets/css/style.css', __FILE__ ), false, $this->version );
        wp_enqueue_style( 'restaurant_system_public_style', plugins_url( 'assets/css/public-style.css', __FILE__ ), false, $this->version );


        wp_enqueue_style( 'restaurant_css', plugins_url( 'includes/admin/assets/css/monoedge_main_css.css', __FILE__ ), false, $this->version );

        wp_enqueue_script( 'thickbox' );
        wp_enqueue_style( 'thickbox' );
    }

    public function add_public_media_scripts( $page ) {
        wp_enqueue_script( 'jquery' );
        wp_enqueue_style( 'restaurant_system_public_style', plugins_url( 'assets/css/public-style.css', __FILE__ ), false, $this->version );
        wp_enqueue_script( 'restaurant_system_public_scripts_js', plugin_dir_url( __FILE__ ) . 'assets/js/public-scripts.js', array(), $this->version, true );
    }

    /*
        * Propagate action to the whole network
        */
    public static function monoedge_propagate_in_network( $networkwide, $action ) {
        global $wpdb;

        if ( function_exists( 'is_multisite' ) && is_multisite() ) {
            if ( $networkwide ) {
                $old_blog_id = $wpdb->blogid;

                // $blogids = $wpdb->get_col( "SELECT blog_id FROM $wpdb->blogs" );

                // Set cache key
                $cache_key = 'network_blog_ids';
                $cache_group = 'monoedge_group';

                // Retrieve blog ID from cache
                $blogids = wp_cache_get( $cache_key, $cache_group );

                if ( false === $blogids ) {
                    // If not present in cache, retrieve from database
                    // $blogids = $wpdb->get_col( "SELECT blog_id FROM $wpdb->blogs" );
                    $blogids = get_sites( array( 'fields' => 'ids' ) );
                    
                    // Set in cache
                    wp_cache_set( $cache_key, $blogids, $cache_group, 3600 ); // 3600秒のキャッシュ有効期限
                }

                foreach ( $blogids as $blog_id ) {
                    switch_to_blog( $blog_id );

                    if ( $action === 'install' ) {
                        self::_monoedge_install();
                        // set Cache
                        wp_cache_set( 'monoedge_install_' . $blog_id, true, 'monoedge_group', 3600 );
                    } else {
                        if ( $action === 'uninstall' ) {
                            self::_monoedge_uninstall();
                            // delete cache
                            wp_cache_delete( 'monoedge_install_' . $blog_id, 'monoedge_group' );
                        }
                    }
                }

                switch_to_blog( $old_blog_id );

                return;
            }
        }

        if ( $action === 'install' ) {
            self::_monoedge_install();
            // set Cache
            wp_cache_set( 'monoedge_install_' . $wpdb->blogid, true, 'monoedge_group', 3600 );
        } else {
            if ( $action === 'uninstall' ) {
                self::_monoedge_uninstall();
                // delete cache
                wp_cache_delete( 'monoedge_install_' . $wpdb->blogid, 'monoedge_group' );
            }
        }
    }

    /*
    * Actions performed on plugin activation
    */
    public static function monoedge_install( $networkwide ) {
        self::monoedge_propagate_in_network( $networkwide, 'install' );

        // self::check_for_elementor_old_widgets_in_posts();
    }

    public static function check_multiple_plugins_activations(){
        // Nonce velification
        if (!isset($_POST['_wpnonce']) || !wp_verify_nonce($_POST['_wpnonce'], 'monoedge-nonce')) {
            exit('Nonce verification failed');
        }
        // don't setup the redirect option if multiple plugins are activated at once
        return ( isset( $_REQUEST[ 'action' ], $_POST[ 'checked' ] ) &&
            'activate-selected' === $_REQUEST[ 'action' ] &&
            count( $_POST[ 'checked' ] ) > 1 );
    }

    public static function check_for_elementor_old_widgets_in_posts(){

        $monoedge_old_widgets_present = 'no';
        $monoedge_elementor_widgets_used = '';
        $all_post_types = get_post_types();
        foreach ( $all_post_types as $post_type ) {
            $skip_post_types = [
                'elementor_library',
                'attachment',
                'nav_menu_item',
                'custom_css',
                'custom_css',
                'customize_changeset',
                'oembed_cache',
                'user_request',
                'wp_block',
                'wp_template',
            ];
            if ( !in_array( $post_type, $skip_post_types, false ) ) {
                $search_posts = get_posts( [ 'numberposts' => '-1', 'post_type' => $post_type ] );
                foreach ( $search_posts as $post ) {
                    $meta_elementor_data = get_post_meta( (int)$post->ID, '_elementor_data', true );
                    if ( !empty( $meta_elementor_data ) ) {
                        $monoedge_elementor_widgets_used .= $meta_elementor_data;
                    }
                }
            }
        }
        if ( strpos( $monoedge_elementor_widgets_used, 'monoedge_elementor_ordering' ) !== false || strpos( $monoedge_elementor_widgets_used, 'monoedge_elementor_monoedge_elementor_reservations' ) !== false ) {
            $monoedge_old_widgets_present = 'yes';
        } else {
            self::monoedge_cron_deactivate_check_elementor();
        }
        update_option( 'monoedge_check_old_widgets_elementor', $monoedge_old_widgets_present );

    }

    public static function _monoedge_install() {
        if ( ! get_option( 'monoedge_installation_id' ) ) {
            update_option( 'monoedge_installation_id', wp_generate_uuid4() );
        }

        if ( self::check_multiple_plugins_activations() ) {
            return;
        }
        add_option( 'monoedge_plugin_redirect', wp_get_current_user()->ID );
    }

    /*
    * Actions performed on plugin uninstall
    */
    public static function monoedge_uninstall() {
        self::monoedge_propagate_in_network( true, 'uninstall' );
    }

    public static function _monoedge_uninstall() {
        delete_option( 'monoedge_installation_id' );
        delete_option( 'monoedge_user_data' );

        // deactivate the cron that checks for old widgets elementor on posts
        self::monoedge_cron_deactivate_check_elementor();
    }

    public static function monoedge_cron_deactivate_check_elementor(){
        wp_clear_scheduled_hook( 'monoedge_cron_check_elementor' );
    }

    public function is_authenticated() {
        // return $this->api_token;
        $_monoedge_user_data = get_option( 'monoedge_user_data' );
        if ( isset($_monoedge_user_data['api_token']) ) {
            if ( strlen($_monoedge_user_data['api_token']) > 0 ) {
                return true;
            }
        } 
        return false;
    }

    public function load_user_data() {
		// $location_data_obj = Monoedge_Utils::Monoedge_more_location_data();
        $user_data_obj = Monoedge_Utils::monoedge_get_all_data();
        $pages               = array( 'user' );

        foreach ( $pages as $key ) {
            $this->$key = $user_data_obj && isset( $user_data_obj ) ? $user_data_obj : null;
        }
        $this->installation_id = get_option( 'monoedge_installation_id' );
    }

    public function remove_user_data() {
        delete_option( 'monoedge_user_data' );
        $this->load_user_data();
    }
    
    public function monoedge_set_script_translations() {
        //wp_set_script_translations( 'menu-ordering-editor', 'monoedge', MONOEDGE_PLUGIN_DIR . 'languages' );
    }
    public function monoedge_load_languages() {
        load_plugin_textdomain( 'monoedge-restaurant-system', false, dirname( plugin_basename( __FILE__ ) ) . '/languages' );
    }

	public static function monoedge_getInstance() {
		if ( ! isset( self::$_instance ) ) {
			self::$_instance = new MONOEDGE_Restaurant_System();
		}

		Monoedge_Utils::$_MONOEDGE = self::$_instance;
        Monoedge_Utils::write_log("[MONOEDGE_Restaurant_System] monoedge_getInstance()");

		return self::$_instance;
	}
}

MONOEDGE_Restaurant_System::monoedge_getInstance();
?>
